{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

{-----------------------------------------------------------------------------
 Unit Name: upp1
 Author:    od
 Purpose:   Dmontrer le copier / coller des objets
 History:   Avril 2002 V 1.0
-----------------------------------------------------------------------------}



unit upp1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,
  ClipBrd;           // indispensable pour grer le presse-papiers

type

  // dfinition d'une classe conteneur pour
  // les informations  copier/coller
  TClient = class(TComponent)
   private
    fSociete : string;
    fContact : string;
    fAdresse : tstrings;
    procedure SetAdresse(ts:tstrings);
   public
    constructor Create(aowner:tcomponent); override;
    Destructor Destroy; override;
   published
    // seules les proprits Published sont sauvegardes
    Property Societe: string read fSociete write fSociete;
    Property Contact:string read fContact write fContact;
    Property Adresse: tstrings read fAdresse write SetAdresse;
   end;


  // la fiche de test
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation
{$R *.dfm}

// Classe TClient

{-----------------------------------------------------------------------------
  Procedure: TClient.Create
  Author:    od
  Date:      01-mai-2002
  Arguments: aowner:tcomponent
  Purpose:   Init de la classe
-----------------------------------------------------------------------------}

Constructor TClient.Create(aowner:tcomponent);
begin
 inherited create(aowner);
 fAdresse := TStringlist.Create;
end;

{-----------------------------------------------------------------------------
  Procedure: TClient.Destroy
  Author:    od
  Date:      01-mai-2002
  Arguments: None
  Purpose:   Destructeur
-----------------------------------------------------------------------------}
Destructor TClient.Destroy;
begin
 FreeAndNil(fAdresse);
 inherited destroy;
end;

{-----------------------------------------------------------------------------
  Procedure: TClient.SetAdresse
  Author:    od
  Date:      01-mai-2002
  Arguments: ts:tstrings
  Purpose:   Modificateur du champ Adresse
-----------------------------------------------------------------------------}
procedure TClient.SetAdresse(ts:tstrings);
begin
 fAdresse.Assign(ts);
end;

// ***** fin de la classe TClient ****


// Opration COPIER
procedure TForm1.Button1Click(Sender: TObject);
var Client:Tclient;
begin
 Client := TClient.Create(self); // cration du conteneur
 with Client do                  // remplissage du conteneur
 try
   Societe := edit1.Text;
   Contact := edit2.Text;
   Adresse := memo1.Lines;
   Clipboard.SetComponent(Client); // copie vers le presse-papiers
 finally
  FreeAndNil(Client);            // libration du conteneur
 end;
end;

{-----------------------------------------------------------------------------
  Procedure: TForm1.Button3Click
  Author:    od
  Date:      01-mai-2002
  Arguments: Sender: TObject
  Purpose:   Vider les contrles cran pour voir l'effet du COLLER
-----------------------------------------------------------------------------}
procedure TForm1.Button3Click(Sender: TObject);
begin
 edit1.Text:='';
 edit2.Text:='';
 memo1.Lines.Clear;
end;

{-----------------------------------------------------------------------------
  Procedure: TForm1.Button2Click
  Author:    od
  Date:      01-mai-2002
  Arguments: Sender: TObject
  Purpose:   Opration COLLER
-----------------------------------------------------------------------------}
procedure TForm1.Button2Click(Sender: TObject);
var Client:TComponent; // on rcupre un TComponent du clipboard
begin
 // le presse-papier contient-il un objet ?
 if not clipboard.HasFormat(CF_COMPONENT) then exit;
 // obtennir l'objet (Tcomponent)
 Client := clipboard.GetComponent(nil,nil);
 try
  // ce composant est-il un Tclient ?
  if not (Client is TClient) then exit;
  with TClient(Client) do
   begin // on dcharge le conteneur dans les contrles cran
    edit1.text:= Societe;
    edit2.text:= Contact;
    memo1.lines := Adresse;
   end;
 finally
  FreeAndNil(Client); // libration du conteneur
 end;
end;

initialization
 // Indispensable au fonctionnement : le recensement de la classe
 RegisterClass(TClient);
end.
