{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit Calculatrice1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, Buttons, ExtCtrls;

type
  TMain = class(TForm)
    Menu: TMainMenu;
    Edition1: TMenuItem;
    Affichage1: TMenuItem;
    N1: TMenuItem;
    Afficheur: TPanel;
    Retour: TSpeedButton;
    CE: TSpeedButton;
    C: TSpeedButton;
    MC: TSpeedButton;
    MR: TSpeedButton;
    MS: TSpeedButton;
    MP: TSpeedButton;
    b7: TSpeedButton;
    b8: TSpeedButton;
    b9: TSpeedButton;
    division: TSpeedButton;
    Racine: TSpeedButton;
    b4: TSpeedButton;
    b5: TSpeedButton;
    b6: TSpeedButton;
    mul: TSpeedButton;
    PourCent: TSpeedButton;
    b1: TSpeedButton;
    b2: TSpeedButton;
    b3: TSpeedButton;
    moins: TSpeedButton;
    Inverse: TSpeedButton;
    b0: TSpeedButton;
    virgule: TSpeedButton;
    plus: TSpeedButton;
    egal: TSpeedButton;
    bSigne: TSpeedButton;
    Copier1: TMenuItem;
    Coller1: TMenuItem;
    Standard1: TMenuItem;
    Scientifique1: TMenuItem;
    AproposdelaCalculatrice1: TMenuItem;
    EnMemoire: TPanel;
    Timer1: TTimer;
    procedure ChiffreClick(Sender: TObject);
    procedure CEClick(Sender: TObject);
    procedure CClick(Sender: TObject);
    procedure RetourClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: AnsiChar);
    procedure FormCreate(Sender: TObject);
    procedure OperationClick(Sender: TObject);
    procedure virguleClick(Sender: TObject);
    procedure bSigneClick(Sender: TObject);
    procedure egalClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MCClick(Sender: TObject);
    procedure MRClick(Sender: TObject);
    procedure MSClick(Sender: TObject);
    procedure MPClick(Sender: TObject);
    procedure RacineClick(Sender: TObject);
    procedure PourCentClick(Sender: TObject);
    procedure InverseClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private

    Efface:boolean; // faut-il effacer la prcdente saisie
    Calcul:boolean; // calcul en cours ?

    Signe:string; // '-' ou ''
    Nombre:string; // partie entire
    Decimales:string; // partie dcimale
    Decimal:boolean; // indique si la virgule est active

    Valeur:single;  // dernier rsultat calcul
    Operation:char; // operation en cours

    Memoire:string; // zone mmoire

    Keys:array['0'..'9'] of TSpeedButton; // les boutons lis aux touches '0'  '9'

    procedure DoClick(Button:TSpeedButton);
  public
    { Dclarations publiques }
  end;

var
  Main: TMain;

implementation

{$R *.dfm}

// Surcharge la fonction FloatToStr pour ajouter la virgule
Function FloatToStr(v:single):string;
 begin
  Result:=SysUtils.FloatToStr(v);
  if pos(DecimalSeparator,Result)=0 then Result:=Result+DecimalSeparator;
 end;

// Cration de la fiche
procedure TMain.FormCreate(Sender: TObject);
var
 i:integer;
 c:TControl;
 s:TSpeedButton absolute c;  // c et s partagent la mme adresse
begin
// pour chaque contrle de la fiche
 for i:=0 to ControlCount-1 do begin
  c:=Controls[i];
 // si c'est un TSpeedButton
  if (c is TSpeedButton)
 // et que son titre fait un caractre de long
  and(length(s.Caption)=1)
 // et qu'il sagit d'un chiffre
  and(s.Caption[1] in ['0'..'9'])
 // alors c'est le bouton d'un chiffre
  then Keys[s.Caption[1]]:=s;
 end;
 CE.Click;
end;

procedure TMain.ChiffreClick(Sender: TObject);
var
 Chiffre:char;
begin
// saisie d'un nouveau nombre
 if Efface then CE.Click;
// saisie maxi
 if Length(Afficheur.Caption)=32 then exit;
// le chiffre en question
 Chiffre:=TSpeedButton(Sender).Caption[1];
// en dcimal ou en entier
 if Decimal then
  Decimales:=Decimales+Chiffre
 else begin
  if Nombre='0' then Nombre:=Chiffre else Nombre:=Nombre+Chiffre;
 end;
// mise  jour de l'afficheur
 Afficheur.Caption:=Signe+Nombre+DecimalSeparator+Decimales;
end;

procedure TMain.virguleClick(Sender: TObject);
begin
 Decimal:=True;
end;

procedure TMain.bSigneClick(Sender: TObject);
begin
 if Signe='' then Signe:='-' else Signe:='';
 Afficheur.Caption:=Signe+Nombre+DecimalSeparator+Decimales;
end;

procedure TMain.CEClick(Sender: TObject);
begin
// CE efface la saisie en cours
 Signe:='';
 Nombre:='0';
 Decimales:='';
 Decimal:=False;
 Efface:=False;
 Afficheur.Caption:='0'+DecimalSeparator;
end;

procedure TMain.CClick(Sender: TObject);
begin
// C efface le dernier rsultat
 CE.Click;
 Valeur:=0;
 Operation:=' ';
end;

procedure TMain.RetourClick(Sender: TObject);
begin
// Retour efface le dernier chiffre du nombre
 if Decimal then begin
  if Decimales='' then
   Decimal:=False
  else
   SetLength(Decimales,Length(Decimales)-1);
 end else begin
  if Length(Nombre)<2 then Nombre:='0' else SetLength(Nombre,Length(Nombre)-1);
 end;
 Afficheur.Caption:=Signe+Nombre+DecimalSeparator+Decimales;
end;

procedure TMain.OperationClick(Sender: TObject);
begin
// Nouvelle operation
 if Calcul then Egal.Click;
 Valeur:=StrToFloat(Afficheur.Caption);
 Operation:=TSpeedButton(Sender).Caption[1];
 Calcul:=True;
 Efface:=True;
end;

procedure TMain.EgalClick(Sender: TObject);
var
 v:single;
 s:string;
begin
 Efface:=True;
 Calcul:=False;
 v:=StrToFloat(Afficheur.Caption);
 case Operation of
  '+': Valeur:=Valeur+v;
  '-': Valeur:=Valeur-v;
  '*': Valeur:=Valeur*v;
  '/': if v=0 then begin
        Afficheur.Caption:='Erreur: nombre infini positif';
        exit;
       end else begin
        Valeur:=Valeur/v;
       end;
 end;
 s:=FloatToStr(Valeur);
 C.Click;
 Afficheur.Caption:=s;
end;

procedure TMain.MCClick(Sender: TObject);
begin
 Memoire:='0'+DecimalSeparator;
 EnMemoire.Caption:='';
end;

procedure TMain.MRClick(Sender: TObject);
begin
 Afficheur.Caption:=Memoire;
end;

procedure TMain.MSClick(Sender: TObject);
begin
 Memoire:=Afficheur.Caption;
 EnMemoire.Caption:='M';
 Efface:=True;
end;

procedure TMain.MPClick(Sender: TObject);
var
 a,b:single;
begin
 a:=StrToFloat(Memoire);
 b:=StrToFloat(Afficheur.Caption);
 Memoire:=FloatToStr(a+b);
end;

procedure TMain.RacineClick(Sender: TObject);
var
 x:single;
begin
 x:=StrToFloat(Afficheur.Caption);
 if x<0 then
  Afficheur.Caption:='Entre incorrecte pour la fonction.'
 else begin
  Afficheur.Caption:=FloatToStr(sqrt(x));
 end;
 Efface:=True;
end;

procedure TMain.PourCentClick(Sender: TObject);
var
 x:single;
begin
 x:=StrToFloat(Afficheur.Caption);
 x:=Valeur*x/100;
 Afficheur.Caption:=FloatToStr(x);
 Efface:=True;
end;

procedure TMain.InverseClick(Sender: TObject);
var
 x:single;
begin
 x:=StrToFloat(Afficheur.Caption);
 if x=0 then
  Afficheur.Caption:='Erreur : nombre infini positif'
 else
  Afficheur.Caption:=FloatToStr(1/x);
 Efface:=True;
end;

procedure TMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 case key of
  vk_return : DoClick(Egal);
  vk_escape : DoClick(C);
  vk_delete : DoClick(CE);
 end;
end;

procedure TMain.FormKeyPress(Sender: TObject; var AnsiKey: Char);
begin
 case Key of
  '0'..'9': DoClick(Keys[Key]);
  ',','.' : DoClick(virgule);
  '/' : DoClick(division);
  '*' : DoClick(mul);
  '-' : DoClick(moins);
  '+' : DoClick(Plus);
 end;
end;

Type
 TPublicSpeedButton=class(TSpeedButton)
 end;

procedure TMain.DoClick(Button:TSpeedButton);
 begin
  TPublicSpeedButton(Button).FState:=bsDown;
  TPublicSpeedButton(Button).Paint;
  Button.Click;
  Timer1.Enabled:=True;
 end;

procedure TMain.Timer1Timer(Sender: TObject);
var
 i:integer;
 c:TControl;
 s:TPublicSpeedButton absolute c;
begin
 Timer1.Enabled:=False;
 for i:=0 to ControlCount-1 do begin
  c:=Controls[i];
  if (c is TSpeedButton)
  and(s.FState=bsDown) then begin
   s.FState:=bsUp;
   s.Paint;
  end;
 end;
end;

end.
