{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Ouvrir1: TMenuItem;
    Enregistrer1: TMenuItem;
    Quitter1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Option1: TMenuItem;
    Associer1: TMenuItem;
    Installer1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure Ouvrir1Click(Sender: TObject);
    procedure Enregistrer1Click(Sender: TObject);
    procedure Associer1Click(Sender: TObject);
    procedure Installer1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
   procedure LoadParams(FileName:string);
   procedure SaveParams(FileName:string);
   function IsLinked:boolean;
   procedure DoLink;
   procedure UnLink;
   function IsInstalled:boolean;
   procedure DoInstall;
   procedure UnInstall;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
 IniFiles,Registry;

procedure TForm1.FormCreate(Sender: TObject);
var
 s:string;
begin
 Associer1.Checked:=IsLinked;
 Installer1.Checked:=IsInstalled;
 if ParamCount>0 then begin
  s:=ParamStr(1);
  if s='/remove' then begin
   UnInstall;
   halt;
  end;
  LoadParams(s);
 end;
end;

procedure TForm1.LoadParams(FileName:string);
begin
 with TIniFile.Create(FileName) do begin
  Top:=ReadInteger('Form1','Top',Top);
  Left:=ReadInteger('Form1','Left',Left);
  Width:=ReadInteger('Form1','Width',width);
  Height:=ReadInteger('Form1','Height',Height);
  Free;
 end;
end;

procedure TForm1.SaveParams(FileName:string);
begin
 with TIniFile.Create(FileName) do begin
  WriteInteger('Form1','Top',Top);
  WriteInteger('Form1','Left',Left);
  WriteInteger('Form1','Width',width);
  WriteInteger('Form1','Height',Height);
  Free;
 end;
end;

function TForm1.IsLinked:boolean;
begin
 Result:=False;
 with TRegistry.Create do begin
  try
   RootKey:=HKEY_CLASSES_ROOT; // extensions de fichiers (entre autre)
   if OpenKey('\.PRM',False)=False then exit;
   if ReadString('')<>'DelphiPRM' then exit;
   if OpenKey('\DelphiPRM',False)=false then exit;
   if ReadString('')<>'Paramtres pour demo Delphi' then exit;
   Result:=True;
  finally
   Free;
  end;
 end;
end;

procedure TForm1.DoLink;
begin
 with TRegistry.Create do begin
  try
  // extensions de fichiers (entre autre)
   RootKey:=HKEY_CLASSES_ROOT;
  // dclarer les fichiers PRM
   if OpenKey('\.PRM',True)=False then exit;
   WriteString('','DelphiPRM');
  // donner un nom type DelphiPRM
   if OpenKey('\DelphiPRM',True)=False then exit;
   WriteString('','Paramtres pour demo Delphi');
  // dfinir la commande Ouvrir de ce type de fichiers
   if OpenKey('\DelphiPRM\Shell\Open\Command',True)=False then exit;
   WriteString('','"'+Application.ExeName+'" %1');
  finally
   Free;
  end;
 end;
end;

procedure TForm1.UnLink;
begin
 with TRegistry.Create do begin
  try
   RootKey:=HKEY_CLASSES_ROOT;
  // si l'association de fichier RPM existe
   if OpenKey('\.PRM',False) then begin
   // qu'elle est bien la notre
    if ReadString('')='DelphiPRM' then begin
    // supprimer la cl
     DeleteKey('\.PRM');
    end;
   end;
  // idem pour le type de fichier
   if OpenKey('\DelphiPRM',False) then begin
    if ReadString('')='Paramtres pour demo Delphi' then begin
     DeleteKey('\DelphiPRM');
    end;
   end;
  finally
   Free;
  end;
 end;
end;

function TForm1.IsInstalled:boolean;
 begin
  Result:=False;
  with TRegistry.Create do begin
   try
    RootKey:=HKEY_LOCAL_MACHINE;
    if OpenKey('\Software\Microsoft\Windows\CurrentVersion\Uninstall\DemoDelphi',False)=false then exit;
    if ReadString('DisplayName')<>'Application demo Delphi' then exit;
    Result:=True;
   finally
    Free;
   end;
  end;
 end;

procedure TForm1.DoInstall;
 begin
  with TRegistry.Create do begin
   try
    RootKey:=HKEY_LOCAL_MACHINE;
    if OpenKey('\Software\Microsoft\Windows\CurrentVersion\Uninstall\DemoDelphi',True)=false then exit;
    WriteString('DisplayName','Application demo Delphi');
    WriteString('UninstallString','"'+ParamStr(0)+'" /remove');
   finally
    Free;
   end;
  end;
 end;

procedure TForm1.UnInstall;
 begin
  UnLink;
  with TRegistry.Create do begin
   try
    RootKey:=HKEY_LOCAL_MACHINE;
    if OpenKey('\Software\Microsoft\Windows\CurrentVersion\Uninstall\DemoDelphi',False)=false then exit;
    if ReadString('DisplayName')<>'Application demo Delphi' then exit;
    DeleteKey('\Software\Microsoft\Windows\CurrentVersion\Uninstall\DemoDelphi');
   finally
    Free;
   end;
  end;
 end;

procedure TForm1.Quitter1Click(Sender: TObject);
begin
 close;
end;

procedure TForm1.Ouvrir1Click(Sender: TObject);
begin
 if OpenDialog1.Execute then LoadParams(OpenDialog1.FileName);
end;

procedure TForm1.Enregistrer1Click(Sender: TObject);
begin
 if SaveDialog1.Execute then SaveParams(SaveDialog1.FileName);
end;

procedure TForm1.Associer1Click(Sender: TObject);
begin
 if Associer1.Checked then begin
  UnLink;
 end else begin
  DoLink;
 end;
 Associer1.Checked:=IsLinked;
end;

procedure TForm1.Installer1Click(Sender: TObject);
begin
 if Installer1.Checked then begin
  UnInstall;
 end else begin
  DoInstall;
 end;
 Installer1.Checked:=IsInstalled;
end;



end.
