{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

// OD - Livre D7

unit Unit1;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, DBXpress, DB, SqlExpr, QExtCtrls, QDBCtrls, QGrids, QDBGrids,
  Provider, DBClient, DBLocal, DBLocalS, QButtons, FMTBcd;

type
  TForm1 = class(TForm)
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    SQLConnection1: TSQLConnection;
    DataSource1: TDataSource;
    Label1: TLabel;
    Edit1: TEdit;
    sbOpen: TSpeedButton;
    OpenDialog1: TOpenDialog;
    btnOuvrir: TButton;
    BtnFermer: TButton;
    BtnStartT: TButton;
    BtnCancelT: TButton;
    BtnValidT: TButton;
    btnAppliquer: TButton;
    SQLTable1: TSQLTable;
    ClientDataSet1: TClientDataSet;
    DataSetProvider1: TDataSetProvider;
    procedure btnOuvrirClick(Sender: TObject);
    procedure BtnFermerClick(Sender: TObject);
    procedure BtnStartTClick(Sender: TObject);
    procedure BtnCancelTClick(Sender: TObject);
    procedure BtnValidTClick(Sender: TObject);
    procedure btnAppliquerClick(Sender: TObject);
    procedure sbOpenClick(Sender: TObject);
  private
    { Dclarations prives }
    TD : TTransactionDesc;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

procedure TForm1.btnOuvrirClick(Sender: TObject);
begin
 SQLConnection1.Params.values['database']:=edit1.text;
 SQLConnection1.Connected:=true;
 SQLTable1.Open;
 ClientDataSet1.Open;
 td.TransactionID := 1;
 td.IsolationLevel := xilREADCOMMITTED;
 SQLConnection1.StartTransaction(td);
end;

procedure TForm1.BtnFermerClick(Sender: TObject);
begin
 If SQLConnection1.InTransaction then
  if MessageDlg('Valider la transaction ?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
     SQLConnection1.Commit(td) else SQLConnection1.Rollback(td);
 ClientDataSet1.Close;
 SQLConnection1.Close;
end;

procedure TForm1.BtnStartTClick(Sender: TObject);
begin
 if not SQLConnection1.InTransaction then
  SQLConnection1.StartTransaction(td);
end;

procedure TForm1.BtnCancelTClick(Sender: TObject);
begin
 if SQLConnection1.InTransaction then
  SQLConnection1.Rollback(td);
end;

procedure TForm1.BtnValidTClick(Sender: TObject);
begin
 if SQLConnection1.InTransaction then
  SQLConnection1.Commit(td);
end;

procedure TForm1.btnAppliquerClick(Sender: TObject);
begin
 ClientDataSet1.ApplyUpdates(-1);
end;

procedure TForm1.sbOpenClick(Sender: TObject);
begin
 if OpenDialog1.Execute then
  Edit1.Text := OpenDialog1.FileName;
end;

end.
