{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

{-----------------------------------------------------------------------------
 Unit Name: umain
 Author:    OD
 Purpose:   dmonstration livre D7 - MyBase / CLX - Calepin tlphonique
 History:   juin 2002 - v 1
-----------------------------------------------------------------------------}



unit umain;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, DB, QActnList, QMenus, QTypes, QExtCtrls, QDBCtrls, QGrids,
  QDBGrids, QComCtrls, DBClient, QDBActns, QStdActns, QMask;

type
  TForm1 = class(TForm)
    cds1: TClientDataSet;
    sb1: TStatusBar;
    DataSource1: TDataSource;
    MainMenu1: TMainMenu;
    ActionList1: TActionList;
    cds1Prnom: TStringField;
    cds1Nom: TStringField;
    cds1Surnom: TStringField;
    cds1TlphoneMaison: TStringField;
    cds1TlphonePortable: TStringField;
    cds1TlphoneTravail: TStringField;
    cds1email: TStringField;
    cds1Siteperso: TStringField;
    cds1Adresse: TMemoField;
    cds1Notes: TMemoField;
    cds1Code: TAutoIncField;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    EditSelectAll1: TEditSelectAll;
    EditDelete1: TEditDelete;
    DataSetFirst1: TDataSetFirst;
    DataSetPrior1: TDataSetPrior;
    DataSetNext1: TDataSetNext;
    DataSetLast1: TDataSetLast;
    DataSetInsert1: TDataSetInsert;
    DataSetDelete1: TDataSetDelete;
    DataSetEdit1: TDataSetEdit;
    DataSetPost1: TDataSetPost;
    DataSetCancel1: TDataSetCancel;
    Fichier1: TMenuItem;
    Edition1: TMenuItem;
    Donnes1: TMenuItem;
    Premier1: TMenuItem;
    Suivante1: TMenuItem;
    Suivante2: TMenuItem;
    Dernier1: TMenuItem;
    N1: TMenuItem;
    Insertion1: TMenuItem;
    Supprimer1: TMenuItem;
    N2: TMenuItem;
    Annuler1: TMenuItem;
    Valider1: TMenuItem;
    Modifier1: TMenuItem;
    Copier1: TMenuItem;
    Coller1: TMenuItem;
    Couper1: TMenuItem;
    N3: TMenuItem;
    Supprimer2: TMenuItem;
    outslectionner1: TMenuItem;
    pcMain: TPageControl;
    tsListe: TTabSheet;
    tsDetail: TTabSheet;
    Panel1: TPanel;
    tcIndex: TTabControl;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    DBEdit5: TDBEdit;
    DBEdit6: TDBEdit;
    DBEdit7: TDBEdit;
    DBEdit8: TDBEdit;
    DBEdit9: TDBEdit;
    DBMemo1: TDBMemo;
    DBMemo2: TDBMemo;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    DBNavigator2: TDBNavigator;
    FichierSauver: TAction;
    Sauvegarderlefichier1: TMenuItem;
    N4: TMenuItem;
    FichierQuitter: TAction;
    Quitter1: TMenuItem;
    od1: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure tcIndexChange(Sender: TObject);
    procedure cds1AfterPost(DataSet: TDataSet);
    procedure cds1AfterDelete(DataSet: TDataSet);
    procedure FichierQuitterExecute(Sender: TObject);
    procedure FichierSauverExecute(Sender: TObject);
  private
    { Dclarations prives }
    fPath : string;
    fFilterField : string;
    fNomCalepin : string;
    procedure CreateFilter;
    procedure CheckValidIndex;
    procedure AppHint(sender:tobject);
    procedure SaveCalepin;
    procedure OpenCalepin;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;


Const
      kNomParam   = 'CALEPIN.PAR';

implementation

{$R *.xfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
fNomCalepin := 'CALEPIN.XML';
fPath := ExtractFilePath(Application.ExeName);
OpenCalepin;
if FileExists(fpath+kNomParam) then
  with tstringlist.create do
   try
     LoadFromFile(fpath+kNomParam);
     tcIndex.TabIndex:=StrToIntDef(Values['CURRENTFILTER'],0);
     CreateFilter;
     cds1.Locate('CODE',StrToIntDef(values['CODE'],0),[]);
   finally
    free;
   end else CreateFilter;
CheckValidIndex;
Application.OnHint := AppHint;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 SaveCalepin;
 with tstringlist.Create do
  try
   Append('CODE='+cds1.fieldbyname('code').AsString);
   Append('CURRENTFILTER='+IntToStr(tcindex.TabIndex));
   savetofile(fpath+kNomParam);
  finally
   free;
  end;
end;

procedure Tform1.CreateFilter;
begin
 cds1.DisableControls;
 try
  cds1.Filtered:=false;
  if tcIndex.TabIndex=27 then exit; // "tout", aucun filtrage
  cds1.Filter := fFilterField+' LIKE '+
    quotedStr(tcIndex.Tabs[tcIndex.TabIndex].Caption+'%');
  cds1.Filtered:=true;
 finally
  cds1.EnableControls;
 end;
end;

procedure TForm1.DBGrid1DblClick(Sender: TObject);
begin
 pcmain.ActivePage := tsDetail;
end;

procedure TForm1.tcIndexChange(Sender: TObject);
begin
 CreateFilter;
end;

procedure TForm1.cds1AfterPost(DataSet: TDataSet);
var s:string;
begin
 cds1.DisableControls;
 try
  s:=cds1.fieldbyname('CODE').AsString;
  cds1.IndexName:='';
  cds1.IndexName:='idxPrenom';
  if trim(s)<>'' then cds1.Locate('CODE',s,[]);
 finally
  cds1.EnableControls;
 end;
 CheckValidIndex;
end;

procedure TForm1.CheckValidIndex;
var i:integer; idx:array[0..26] of integer;
    s:string; ch:char;
begin
 fillchar(idx,sizeof(idx),0);
 s:=cds1.fieldbyname('CODE').AsString;
 cds1.DisableControls;
 try
  cds1.Filtered:=false;
  cds1.First;
  while not cds1.Eof do
   begin
    ch:=Upcase( copy(cds1.FieldByName('Prenom').AsString+' ',1,1)[1]);
    if ch in ['0'..'9'] then ch:='0';
    if ch in ['A'..'Z'] then inc(idx[ord(ch)-65]);
    if ch='0' then inc(idx[26]);
    cds1.Next;
   end;
  for i:=0 to 26 do
   tcIndex.Tabs[i].Enabled := idx[i]>0;
  cds1.Filtered:=true;
  if trim(s)<>'' then cds1.Locate('CODE',s,[]);
 finally
  cds1.EnableControls;
 end;
end;

procedure TForm1.cds1AfterDelete(DataSet: TDataSet);
begin
 CheckValidIndex;
end;

procedure TForm1.AppHint(sender:tobject);
begin
 sb1.SimpleText:=Application.Hint;
end;

procedure TForm1.FichierQuitterExecute(Sender: TObject);
begin
 Close;
end;

procedure TForm1.FichierSauverExecute(Sender: TObject);
begin
 SaveCalepin;
end;

procedure Tform1.SaveCalepin;
begin
 if cds1.Active then
    cds1.SaveToFile(fpath+fNomCalepin,dfXML);
end;

Procedure TForm1.OpenCalepin;
begin
if not fileExists(fpath+fNomCalepin) then
                  cds1.CreateDataSet else
                  cds1.LoadFromFile(fpath+fNomCalepin);
fFilterField := 'Prenom';
cds1.AddIndex('idxPrenom','Prenom',[ixCaseInsensitive]);
cds1.IndexName:='idxPrenom';
end;

end.
