{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit wChat1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls,  ExtCtrls, AppEvnts, EditFrame, ShellAPI,
  ScktComp;

type
  TMainForm = class(TForm)
    Edit1: TEdit;
    Clients: TListBox;
    Editor1: TEditor;
    Panel1: TPanel;
    Label1: TLabel;
    ClientSocket1: TClientSocket;
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure FormActivate(Sender: TObject);
    procedure ClientsDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure Label1Click(Sender: TObject);
    procedure ClientSocket1Connecting(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
    fName :string;
    fColor:string;
    Buffer:string;
    Status:integer;
    procedure Say(s:string);
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
 wChat2;

procedure TMainForm.FormActivate(Sender: TObject);
begin
 if ClientSocket1.Active=False then begin
  LoginForm:=TLoginForm.Create(Application);
  if LoginForm.ShowModal=mrCancel then begin
   Application.Terminate;
   exit;
  end;
  ClientSocket1.Host:=LoginForm.Edit1.Text;
  fName:=LoginForm.Edit2.Text;
  fColor:=IntToHex(LoginForm.ColorBox1.Selected,8);
  LoginForm.free;
  Clients.Items.Add(fName);
  ClientSocket1.Open;
 end;
end;

procedure TMainForm.Say(s:string);
 begin
  ClientSocket1.Socket.SendText(fName+s+#13#10);
 end;

procedure TMainForm.Edit1KeyPress(Sender: TObject; var Key: Char);
var
 s:string;
 i:integer;
begin
 if key=#13 then begin
  s:=edit1.text;
  edit1.text:='';
  key:=#0;
  if s='exit' then begin
   Close;
   exit;
  end;
  if s='help' then begin
   Editor1.Lines.BeginUpdate;
   for i:=low(Smiles) to High(Smiles) do begin
    s:=Smiles[i];
    Editor1.Lines.Add(' '+s[1]+' '+s[2]+' '+s);
   end;
   Editor1.Lines.Add('"exit" pour sortir');
   Editor1.Lines.EndUpdate;
   exit;
  end;
  Say('> '+s);
 end;
end;

procedure TMainForm.ClientsDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
begin
 with Clients,Canvas do begin
  Font.Color:=integer(Items.Objects[Index]);
  TextRect(Rect,Rect.Left,Rect.Top,Items[Index]);
 end;
end;

procedure TMainForm.ClientSocket1Connecting(Sender: TObject;
  Socket: TCustomWinSocket);
begin
 Editor1.Lines.Add('Recherche du serveur en cours...');
end;

procedure TMainForm.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
 Editor1.Lines.Add('Serveur trouv 8)');
 // envoie de la requte HTTP de dpart
 Socket.SendText('GET /wChat HTTP 1.0'#13#10#13#10);
 Say('>$'+fColor);
end;

procedure TMainForm.ClientSocket1Disconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
 Editor1.Lines.Add('Serveur dconnect :(');
end;

procedure TMainForm.ClientSocket1Error(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
 Editor1.Lines.Add('Erreur serveur :]');
end;

procedure TMainForm.ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
var
 i:integer;
 j:integer;
 c:integer;
 s:string;
 n:string;
begin
// accumulation dans le tampon de lecture
 Buffer:=Buffer+Socket.ReceiveText;

// dcoupage suivant la fin de ligne
 i:=pos(#13#10,Buffer);

 while i>0 do begin

 // extraire le message du buffer
  s:=copy(Buffer,1,i-1);
  Delete(Buffer,1,i+1);

 // ignorer les lignes vierges.
  if s<>'' then 

 // il faut traiter les deux premires lignes HTTP
  case status of
   0: if s='HTTP/1.0 200 OK' then begin
       status:=1;
      end else begin
       Editor1.Lines.Add('Rponse du serveur invalide :(');
       ClientSocket1.Close;
       exit;
      end;
   1: if s='Content-type: text/plain' then begin
       status:=2;
      end else begin
       Editor1.Lines.Add('Rponse incomplte du serveur :(');
       ClientSocket1.Close;
       exit;
      end;
   else begin
    // recherche du sparateur de nom
     i:=pos('>',s);
     if (i>0)and(i<length(s)) then begin

     // le nom et son index dans la liste des clients
      n:=copy(s,1,i-1);
      j:=Clients.Items.IndexOf(n);

      case s[i+1] of
     // message de dconnexion
       '!': begin
             if j>=0 then Clients.Items.Delete(j);
            end;
     // message de couleur
       '$': begin
             c:=StrToInt(copy(s,i+1,9));
             if j>=0 then begin
              Clients.Items.Objects[j]:=TObject(c);
              Clients.Invalidate;
             end else begin
              Clients.Items.AddObject(n,TObject(c));
              Say('>$'+fColor);
             end;
            end
     // sinon, message standard
       else begin
             if j>=0 then begin
              Editor1.Lines.AddObject(s,Clients.Items.Objects[j]);
             end else begin
              Clients.Items.Add(n);
              Editor1.Lines.Add(s);
              Say('>$'+fColor);
             end;
            end;
       end;
     end;
   end;
  end;

  i:=pos(#13#10,Buffer);
 end;
end;

procedure TMainForm.Label1Click(Sender: TObject);
begin
 ShellExecute(Handle,nil,'mailto:tothpaul@free.fr',nil,nil,0);
end;


procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 CanClose:=True;
 if ClientSocket1.Active then begin
  if MessageDlg('Voulez-vous quitter le chat ?',mtConfirmation,[mbYes, mbNo],0)=idNo then
   CanClose:=False
  else
   Say('>!'); // informer les autres de notre dpart
 end;
end;

end.
