{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit Unit2;

interface

uses
  Windows,SysUtils, Classes, HTTPApp, HTTPProd, DB, DBTables, DBWeb, DSProd,
  DBBdeWeb, DBXpressWeb,Graphics;

type
  TWebModule2 = class(TWebModule)
    Welcome: TPageProducer;
    Biolife: TDataSetTableProducer;
    Table1: TTable;
    biolife2: TDataSetPageProducer;
    dbsearch: TQueryTableProducer;
    Query1: TQuery;
    Table1Category: TStringField;
    Table1Common_Name: TStringField;
    Table1Lengthcm: TFloatField;
    Table1Graphic: TGraphicField;
    Session1: TSession;
    procedure WebModule2ImgAction(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure WelcomeHTMLTag(Sender: TObject; Tag: TTag;
      const TagString: String; TagParams: TStrings;
      var ReplaceText: String);
    procedure Table1GraphicGetText(Sender: TField; var Text: String;
      DisplayText: Boolean);
    procedure WebModule2WebActionItem4Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  WebModule2: TWebModule2;

implementation

uses WebReq,Jpeg;

{$R *.DFM}

procedure TWebModule2.WebModule2ImgAction(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
 n:string;
 s:TStream;
begin
 n:=Request.QueryFields.Values['name']+'.jpg';
 try
  s:=TFileStream.Create(n,fmOpenRead or fmShareDenyNone);
  Response.ContentType:='image/jpeg';
  Response.ContentStream:=s;
 except
  Response.StatusCode:=404;
  Response.ReasonString:='Ressource "'+n+'" non trouve';
  Response.Content:='<html><body>fichier non trouv</body></html>';
 end;
end;

procedure TWebModule2.WelcomeHTMLTag(Sender: TObject; Tag: TTag;
  const TagString: String; TagParams: TStrings; var ReplaceText: String);
begin
 if TagString='THIS' then ReplaceText:=Request.PathInfo;
end;

procedure TWebModule2.Table1GraphicGetText(Sender: TField;
  var Text: String; DisplayText: Boolean);
begin
 Text:='<img src="dbimage">';
end;

procedure TWebModule2.WebModule2WebActionItem4Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
 B:TBitmap;
 J:TJPegImage;
 S:TMemoryStream;
begin
 try
  J:=TJpegImage.Create;
  try
   B:=TBitmap.Create;
   try
    B.Assign(Table1Graphic);
    J.Assign(B);
   finally
    B.Free;
   end;
   S:=TMemoryStream.Create;
   J.SaveToStream(S);
  finally
   J.Free;
  end;
  S.Position:=0;
  Response.ContentType:='image/jpeg';
  Response.ContentStream:=S;
 except
  on e:Exception do begin
   Response.StatusCode:=404;
   Response.ContentType:='text/plain';
   Response.Content:='Exception : '+e.Message;
  end;
 end;
end;

initialization
  if WebRequestHandler <> nil then
    WebRequestHandler.WebModuleClass := TWebModule2;

end.
