{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Prendre: TButton;
    Rendre: TButton;
    procedure PrendreClick(Sender: TObject);
    procedure RendreClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    Mutex:THandle;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
// Cration (ou ouverture) du Mutex ds le dpart
 Mutex:=CreateMutex(nil,True,'Mutex.Demo.Delphi7');
 if Mutex=0 then begin
  ShowMessage('Erreur de cration du Mutex !');
 end else begin
 // s'il existe dj :
  if GetLastError=ERROR_ALREADY_EXISTS then begin
   ShowMessage('Le Mutex existe dj');
   Prendre.Enabled:=True; // il faudra le rclamer
   Rendre.Enabled:=False; // nous ne le possdons pas
  end else begin
   Prendre.Enabled:=False; // nous le possdons
   Rendre.Enabled:=True;  // il faudra le librer
  end;
 end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 CloseHandle(Mutex);
end;

procedure TForm1.PrendreClick(Sender: TObject);
begin
 if WaitForSingleObject(Mutex,500)=WAIT_TIMEOUT then begin
  ShowMessage('Mutex non disponible');
  exit;
 end;
 Beep;
 Prendre.Enabled:=False;
 Rendre.Enabled:=True;
end;

procedure TForm1.RendreClick(Sender: TObject);
begin
 ReleaseMutex(Mutex);
 Rendre.Enabled:=False;
 Prendre.Enabled:=True;
end;

end.
