{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
 TWaitThread=class(TThread)
 private
  fLabel:TLabel;
  procedure Blink;
 protected
  Constructor Create(ALabel:TLabel);
  procedure Execute; override;
  procedure Stop;
 end;

  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
    Thread:TThread;
    Wait:TWaitThread;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure run(cmd:string; txt:TStrings);
var
 PipeIn  :THandle;
 PipeOut :THandle;

 StartupInfo: TStartupInfo;
 ProcessInfo: TProcessInformation;

 Buffer: array[0..4096] of Char;
 NbRead: DWord;
begin
// Crer un pipe d'entres/sorties
 CreatePipe(PipeIn,PipeOut,nil,0);
// Crer le process en redirigeant les E/S
 FillChar(StartupInfo, SizeOf(TStartupInfo),0);
 StartupInfo.cb         :=SizeOf(TStartupInfo);
 StartupInfo.dwFlags    :=STARTF_USESHOWWINDOW or STARTF_USESTDHANDLES;
 StartupInfo.wShowWindow:=SW_HIDE;
 StartupInfo.hStdInput  :=PipeIn;
 StartupInfo.hStdOutput :=PipeOut;
 StartupInfo.hStdError  :=PipeOut;
 CreateProcess(nil,PChar(cmd),nil,nil,True,0,nil,nil,StartupInfo,ProcessInfo);
// attendre la fin du process
 WaitForSingleObject(ProcessInfo.hProcess,INFINITE);
// Fermer la sortie
 CloseHandle(PipeOut);
// pour relire le tout
 while ReadFile(PipeIn,Buffer,4096,NbRead,nil) do txt.Add(Buffer);
// fin
 CloseHandle(PipeIn);
end;

Type
 TRunThread=class(TThread)
 private
  fForm1:TForm1;
  fList :TStringList;
  procedure UpdateForm1;
 protected
  Constructor Create(AForm1:TForm1);
  Destructor Destroy; override;
  procedure Execute; override;
 end;

Constructor TRunThread.Create(AForm1:TForm1);
 begin
  fForm1:=AForm1;
  fForm1.Wait.Resume;
  fList :=TStringList.Create;
  FreeOnTerminate:=True;
  inherited Create(False);
 end;

Destructor TRunThread.Destroy;
 begin
  fList.Free;
  inherited;
 end;

procedure TRunThread.Execute;
 begin
  run('ping.exe 127.0.0.1',fList);
  Synchronize(UpdateForm1);
 end;

procedure TRunThread.UpdateForm1;
 begin
  Form1.Memo1.Lines.AddStrings(fList);
  Form1.Thread:=nil;
  Form1.Wait.Stop;
  Beep;
 end;

Constructor TWaitThread.Create(ALabel:TLabel);
 begin
  fLabel:=ALabel;
  inherited Create(True);
 end;

procedure TWaitThread.Blink;
 begin
  fLabel.Visible:=not fLabel.Visible;
 end;

procedure TWaitThread.Stop;
 begin
  Suspend;
  fLabel.Visible:=False;
 end;

procedure TWaitThread.Execute;
 begin
  repeat
   Sleep(500);
   Synchronize(Blink);
  until Terminated;
 end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 if Thread<>nil then begin
  ShowMessage('Un ping est dj en cours');
  exit;
 end;
 Thread:=TRunThread.Create(Self);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 memo1.lines.Clear;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Wait:=TWaitThread.Create(Label1);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 Thread.Free;
 Wait.Free;
end;

end.
