{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, AppEvnts;

type
  TPingPongThread=class(TThread)
  private
   fName:string;
   fList:TListBox;
  protected
   Constructor Create(AName:string; AListBox:TListBox);
   procedure Execute; override;
  end;

  TForm1 = class(TForm)
    ListBox1: TListBox;
    ApplicationEvents1: TApplicationEvents;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
    Ping,Pong:TPingPongThread;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
 LockList:TRTLCriticalSection;

Constructor TPingPongThread.Create(AName:string; AListBox:TListBox);
 begin
  fName:=AName;
  fList:=AListBox;
  FreeOnTerminate:=False;
  inherited Create(False);
 end;

Procedure TPingPongThread.Execute;
 begin
  while not Terminated do begin
   if Random(100)<25 then  begin
    EnterCriticalSection(LockList);
    try
     fList.Items.Add(fName+'['+IntToStr(fList.Items.Count)+']');
    finally
     LeaveCriticalSection(LockList);
    end;
   end;
   Sleep(500);
  end;
 end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 InitializeCriticalSection(LockList);
 Ping:=TPingPongThread.Create('ping',ListBox1);
 Pong:=TPingPongThread.Create('pong',ListBox1);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 Ping.Free;
 Pong.Free;
 DeleteCriticalSection(LockList);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 EnterCriticalSection(LockList);
 try
  ListBox1.Clear;
 finally
  LeaveCriticalSection(LockList);
 end;
end;

end.
