{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit IPlugins;

interface

uses
 Windows,Classes,SysUtils;

Type
 IPlugin=interface(IInterface)
  procedure DoClick; stdcall;
  function Caption:pchar; stdcall;
  function ShortCut:TShortCut; stdcall;
  function Bitmap:THandle; stdcall;
 end;

 TCreatePlugin=function:IPlugin; stdcall;

 TPlugin=class
 private
  fHandle :THandle;
  fCreate :TCreatePlugin;
  fPlugin :IPlugin;
 public
  Constructor Create(FileName:string);
  Destructor Destroy; override;
  property Instance:IPlugin read fPlugin;
 end;

implementation

Constructor TPlugin.Create(FileName:string);
 begin
 // Chargement de la DLL
  fHandle:=LoadLibrary(PChar(FileName));
  if fHandle=0 then raise Exception.Create('Impossible de charger la DLL');
 // Recherche de la fonction d'init
  fCreate:=GetProcAddress(fHandle,'CreatePlugin');
  if @fCreate=nil then raise Exception.Create('Ce n''est pas un i-plugin');
 // Cration du plugin
  fPlugin:=fCreate;
 end;

Destructor TPlugin.Destroy;
 begin
 // Librer l'interface avec un appel automatique  "_Release" confirm
 // par le message "Bye !" dans le Destructor du plugin
  fPlugin:=nil;
 // Libration de la DLL
  if fHandle<>0 then FreeLibrary(fHandle);
  inherited;
 end;

end.
