{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit plugins;

interface

uses
 Windows,Classes,SysUtils;

Type
 TPluginOptions=record
  Caption :PChar;
  OnClick :procedure; stdcall;
  ShortCut:TShortCut;
  Bitmap  :THandle;
 end;

 TInitPlugin=procedure(var Options:TPluginOptions); stdcall;

 TPlugin=class
 private
  fHandle :THandle;
  fInit   :TInitPlugin;
  fOptions:TPluginOptions;
 public
  Constructor Create(FileName:string);
  Destructor Destroy; override;
  Procedure DoClick;
  Property Caption:PChar read fOptions.Caption;
  Property ShortCut:TShortCut read fOptions.ShortCut;
  Property Bitmap:THandle read fOptions.Bitmap;
 end;

implementation

Constructor TPlugin.Create(FileName:string);
 begin
 // Chargement de la DLL
  fHandle:=LoadLibrary(PChar(FileName));
  if fHandle=0 then raise Exception.Create('Impossible de charger la DLL');
 // Recherche de la fonction d'init
  fInit:=GetProcAddress(fHandle,'InitPlugin');
  if @fInit=nil then raise Exception.Create('Ce n''est pas un plugin');;
 // Lecture des options
  fInit(fOptions);
 end;

Destructor TPlugin.Destroy;
 begin
 // Libration de la DLL
  if fHandle<>0 then FreeLibrary(fHandle);
  inherited;
 end;

Procedure TPlugin.DoClick;
 begin
  if @fOptions.OnClick<>nil then fOptions.OnClick;
 end;

end.
