{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, ExtCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    PluginsMenu: TMenuItem;
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Dclarations prives }
    PlugList:TList;
    procedure PluginClick(Sender:TObject);
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
 IPlugins;

procedure TForm1.FormCreate(Sender: TObject);
var
 Path     :string;
 SearchRec:TSearchRec;
 Plugin   :TPlugin;
 Menu     :TMenuItem;
begin
// La liste des plugins chargs
 PlugList:=TList.Create;
// Le rpertoire contenant les plugins
 Path:=ExtractFilePath(Application.ExeName);
// Recherche toutes les DLL
 if FindFirst(Path+'*.DLL',faAnyFile,SearchRec)=0 then begin
  repeat
   ListBox1.Items.Add(SearchRec.Name);
   try
   // On essaye d'en faire un Plugin
    Plugin:=TPlugIn.Create(SearchRec.Name);
    PlugList.Add(Plugin);
    Menu:=NewItem(Plugin.Instance.Caption,Plugin.Instance.ShortCut,False, True, PluginClick, 0, '');
    Menu.Bitmap.Handle:=Plugin.Instance.Bitmap;
   // faire le lien entre le TMenuItem et le TPlugIn pour l'vnement PlugInClick ci-dessous
    Menu.Tag:=integer(Plugin);
    PlugInsMenu.Add(Menu);
   except
    on e:Exception do ListBox1.Items.Add(e.Message);
   end;
  until FindNext(SearchRec)<>0;
 end;
 FindClose(SearchRec);
end;

procedure TForm1.FormDestroy(Sender: TObject);
var
 i:integer;
begin
// libration de tous les plugins
 for i:=0 to PlugList.Count-1 do TPlugin(PlugList[i]).Free;
 PlugList.Free;
end;

procedure TForm1.PluginClick(Sender:TObject);
 var
  tag:integer;
 begin
 // Appelle la procdure DoClick du plugin associ
  if Sender is TMenuItem then begin
   Tag:=TMenuItem(Sender).Tag;
   if TObject(Tag) is TPlugin then TPlugin(Tag).Instance.DoClick;
  end;
 end;

end.
