{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// Nous avons besoin de OleCheck (ComObj) et des Interfaces ActiveX.
uses
 ComObj,ActiveX;

// le CLSID de PDF
const
 PDF:TGUID='{CA8A9780-280D-11CF-A24D-444553540000}';

// l'interface IPDF avec la seule mthode dont nous avons besoin
type
 IPDF = dispinterface
  ['{CA8A9781-280D-11CF-A24D-444553540000}']
  property src: WideString dispid 1;
 end;

// une classe drive directement de TInterfacedObject pour grer l'ActiveX
 TActiveX=class(TInterfacedObject,IOleClientSite,IOleInPlaceSite)
 private
 // init
  ClassID:TGUID;
  Parent :HWnd;
  Left   :integer;
  Top    :integer;
  Width  :integer;
  Height :integer;
 // ole
  OleObject :IOleObject;
  MiscStatus:integer;
  Stream    :IPersistStreamInit;
 protected
 // IOleClientSite
  function SaveObject: HResult; stdcall;
  function GetMoniker(dwAssign: Longint; dwWhichMoniker: Longint;  out mk: IMoniker): HResult; stdcall;
  function GetContainer(out container: IOleContainer): HResult; stdcall;
  function ShowObject: HResult; stdcall;
  function OnShowWindow(fShow: BOOL): HResult; stdcall;
  function RequestNewObjectLayout: HResult; stdcall;
 // IOleWindow
  function ContextSensitiveHelp(fEnterMode: BOOL): HResult; stdcall;
  function GetWindow(out wnd: HWnd): HResult; stdcall;
 // IOleInPlaceSite
  function CanInPlaceActivate: HResult; stdcall;
  function OnInPlaceActivate: HResult; stdcall;
  function OnUIActivate: HResult; stdcall;
  function GetWindowContext(out frame: IOleInPlaceFrame;
    out doc: IOleInPlaceUIWindow; out rcPosRect: TRect;
    out rcClipRect: TRect; out frameInfo: TOleInPlaceFrameInfo): HResult;
    stdcall;
  function Scroll(scrollExtent: TPoint): HResult; stdcall;
  function OnUIDeactivate(fUndoable: BOOL): HResult; stdcall;
  function OnInPlaceDeactivate: HResult; stdcall;
  function DiscardUndoState: HResult; stdcall;
  function DeactivateAndUndo: HResult; stdcall;
  function OnPosRectChange(const rcPosRect: TRect): HResult; stdcall;
 public
  Constructor Create(AClassID:TGUID; AParent:HWnd; ALeft,ATop,AWidth,AHeight:integer);
  Destructor Destroy; override;
 end;

Constructor TActiveX.Create(AClassID:TGUID; AParent:HWnd; ALeft,ATop,AWidth,AHeight:integer);
 begin
 // copie local des infos
  ClassID:=AClassID;
  Parent :=AParent;
  Left   :=ALeft;
  Top    :=ATop;
  Width  :=AWidth;
  Height :=AHeight;

 // cration de la CoClasse OLE
  OleCheck(
   CoCreateInstance(
    ClassID,nil,
    CLSCTX_INPROC_SERVER or CLSCTX_LOCAL_SERVER,
    IOleObject,OleObject
   )
  );

 // rcuprer les flags
  OleCheck(
   OleObject.GetMiscStatus(DVASPECT_CONTENT, MiscStatus)
  );

 // au besoin au place le composant sur notre "site"
  if (MiscStatus and OLEMISC_SETCLIENTSITEFIRST)<>0 then
   OleCheck(OleObject.SetClientSite(Self));

 // rcuprer l'objet flux
  OleCheck(
   OleObject.QueryInterface(IPersistStreamInit, Stream)
  );
 // l'initialiser
  OleCheck(Stream.InitNew);

 // placer l'objet
  OleObject.DoVerb(
   OLEIVERB_INPLACEACTIVATE,
   nil, Self, 0, Parent,
   Rect(Left,Top,Left+width,Top+Height)
  );
 end;

Destructor TActiveX.Destroy;
 begin
  Stream:=nil;
  OleObject:=nil;
  inherited;
 end;

// IOLEClientSite, il suffit de rpondre OK ou NON...

function TActiveX.SaveObject: HResult;
begin
  Result := S_OK;
end;

function TActiveX.GetMoniker(dwAssign: Longint; dwWhichMoniker: Longint; out mk: IMoniker): HResult;
begin
  Result := E_NOTIMPL;
end;

function TActiveX.GetContainer(out container: IOleContainer): HResult;
begin
  Result := E_NOINTERFACE;
end;

function TActiveX.ShowObject: HResult;
begin
 Result := S_OK;
end;

function TActiveX.OnShowWindow(fShow: BOOL): HResult;
begin
 Result := S_OK;
end;

function TActiveX.RequestNewObjectLayout: HResult;
begin
 Result:= E_NOTIMPL;
end;

// IOleWindow, juste OK :)

function TActiveX.ContextSensitiveHelp(fEnterMode: BOOL): HResult;
begin
  Result := S_OK;
end;

function TActiveX.GetWindow(out wnd: HWnd): HResult;
begin
  wnd    := Parent;
  Result := S_OK;
end;

// IOleInPlanceSite, l c'est un peu plus verbeux

function TActiveX.CanInPlaceActivate: HResult;
begin
  Result := S_OK;
end;

function TActiveX.OnInPlaceActivate: HResult;
begin
  Result := S_OK;
end;

function TActiveX.OnUIActivate: HResult;
begin
  Result := S_OK;
end;

function TActiveX.GetWindowContext(out frame: IOleInPlaceFrame;
  out doc: IOleInPlaceUIWindow; out rcPosRect: TRect;
  out rcClipRect: TRect; out frameInfo: TOleInPlaceFrameInfo): HResult;
begin
  frame:= nil;
  doc  := nil;
  rcPosRect:=Rect(Left,Top,Left+width,Top+Height);
  SetRect(rcClipRect, 0, 0, 32767, 32767);
  with frameInfo do begin
   fMDIApp       := False;
   hWndFrame     := Parent;
   hAccel        := 0;
   cAccelEntries := 0;
  end;
  Result := S_OK;
end;

function TActiveX.Scroll(scrollExtent: TPoint): HResult;
begin
  Result := E_NOTIMPL;
end;

function TActiveX.OnUIDeactivate(fUndoable: BOOL): HResult;
begin
  Result := S_OK;
end;

function TActiveX.OnInPlaceDeactivate: HResult;
begin
  Result := S_OK;
end;

function TActiveX.DiscardUndoState: HResult;
begin
  Result := E_NOTIMPL;
end;

function TActiveX.DeactivateAndUndo: HResult;
begin
  Result := S_OK;
end;

function TActiveX.OnPosRectChange(const rcPosRect: TRect): HResult;
begin
  Result := S_OK;
end;

// l'application elle mme

procedure TForm1.FormCreate(Sender: TObject);
var
 A:TActiveX;
 P:IPDF;
begin
 A:=TActiveX.Create(PDF,Handle,10,10,300,400);
 P:=A.OleObject as IPDF;
 P.src:=ExtractFilePath(Application.ExeName)+'..\PDF\Acrobat.pdf';
end;

end.
