{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit ActiveChatImpl;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ActiveX, AxCtrls, ChatX_TLB, StdVcl, EditFrame;

type
  TActiveChat = class(TActiveForm, IActiveChat)
    Editor1: TEditor;
  private
    { Dclarations prives }
    FEvents: IActiveChatEvents;
    procedure ActivateEvent(Sender: TObject);
    procedure ClickEvent(Sender: TObject);
    procedure CreateEvent(Sender: TObject);
    procedure DblClickEvent(Sender: TObject);
    procedure DeactivateEvent(Sender: TObject);
    procedure DestroyEvent(Sender: TObject);
    procedure KeyPressEvent(Sender: TObject; var Key: Char);
    procedure PaintEvent(Sender: TObject);
  protected
    { Dclarations protges }
    procedure DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage); override;
    procedure EventSinkChanged(const EventSink: IUnknown); override;
    function Get_Active: WordBool; safecall;
    function Get_AlignDisabled: WordBool; safecall;
    function Get_AutoScroll: WordBool; safecall;
    function Get_AutoSize: WordBool; safecall;
    function Get_AxBorderStyle: TxActiveFormBorderStyle; safecall;
    function Get_Caption: WideString; safecall;
    function Get_Color: OLE_COLOR; safecall;
    function Get_Cursor: Smallint; safecall;
    function Get_DoubleBuffered: WordBool; safecall;
    function Get_DropTarget: WordBool; safecall;
    function Get_Enabled: WordBool; safecall;
    function Get_Font: IFontDisp; safecall;
    function Get_HelpFile: WideString; safecall;
    function Get_HelpKeyword: WideString; safecall;
    function Get_HelpType: TxHelpType; safecall;
    function Get_KeyPreview: WordBool; safecall;
    function Get_PixelsPerInch: Integer; safecall;
    function Get_PrintScale: TxPrintScale; safecall;
    function Get_Scaled: WordBool; safecall;
    function Get_Visible: WordBool; safecall;
    function Get_VisibleDockClientCount: Integer; safecall;
    procedure _Set_Font(var Value: IFontDisp); safecall;
    procedure Set_AutoScroll(Value: WordBool); safecall;
    procedure Set_AutoSize(Value: WordBool); safecall;
    procedure Set_AxBorderStyle(Value: TxActiveFormBorderStyle); safecall;
    procedure Set_Caption(const Value: WideString); safecall;
    procedure Set_Color(Value: OLE_COLOR); safecall;
    procedure Set_Cursor(Value: Smallint); safecall;
    procedure Set_DoubleBuffered(Value: WordBool); safecall;
    procedure Set_DropTarget(Value: WordBool); safecall;
    procedure Set_Enabled(Value: WordBool); safecall;
    procedure Set_Font(const Value: IFontDisp); safecall;
    procedure Set_HelpFile(const Value: WideString); safecall;
    procedure Set_HelpKeyword(const Value: WideString); safecall;
    procedure Set_HelpType(Value: TxHelpType); safecall;
    procedure Set_KeyPreview(Value: WordBool); safecall;
    procedure Set_PixelsPerInch(Value: Integer); safecall;
    procedure Set_PrintScale(Value: TxPrintScale); safecall;
    procedure Set_Scaled(Value: WordBool); safecall;
    procedure Set_Visible(Value: WordBool); safecall;
    function Get_LineCount: Integer; safecall;
    function Get_Lines(Index: Integer): WideString; safecall;
    procedure AddLine(const Text: WideString; Color: Integer); safecall;
    procedure Set_Lines(Index: Integer; const Value: WideString); safecall;
    function Get_Text: WideString; safecall;
    procedure Set_Text(const Value: WideString); safecall;
  public
    { Dclarations publiques }
    procedure Initialize; override;
  end;

implementation

uses ComObj, ComServ, Unit1;

{$R *.DFM}

{ TActiveChat }

procedure TActiveChat.DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage);
begin
  { Dfinir des pages de proprits ici. Les pages de proprits sont dfinies en
     appelant DefinePropertyPage avec l'id de classe de la page.  Exemple :
      DefinePropertyPage(Class_ActiveChatPage); }
  DefinePropertyPage(Class_PropertyPage1);
end;

procedure TActiveChat.EventSinkChanged(const EventSink: IUnknown);
begin
  FEvents := EventSink as IActiveChatEvents;
  inherited EventSinkChanged(EventSink);
end;

procedure TActiveChat.Initialize;
begin
  inherited Initialize;
  OnActivate := ActivateEvent;
  OnClick := ClickEvent;
  OnCreate := CreateEvent;
  OnDblClick := DblClickEvent;
  OnDeactivate := DeactivateEvent;
  OnDestroy := DestroyEvent;
  OnKeyPress := KeyPressEvent;
  OnPaint := PaintEvent;
end;

function TActiveChat.Get_Active: WordBool;
begin
  Result := Active;
end;

function TActiveChat.Get_AlignDisabled: WordBool;
begin
  Result := AlignDisabled;
end;

function TActiveChat.Get_AutoScroll: WordBool;
begin
  Result := AutoScroll;
end;

function TActiveChat.Get_AutoSize: WordBool;
begin
  Result := AutoSize;
end;

function TActiveChat.Get_AxBorderStyle: TxActiveFormBorderStyle;
begin
  Result := Ord(AxBorderStyle);
end;

function TActiveChat.Get_Caption: WideString;
begin
  Result := WideString(Caption);
end;

function TActiveChat.Get_Color: OLE_COLOR;
begin
  Result := OLE_COLOR(Color);
end;

function TActiveChat.Get_Cursor: Smallint;
begin
  Result := Smallint(Cursor);
end;

function TActiveChat.Get_DoubleBuffered: WordBool;
begin
  Result := DoubleBuffered;
end;

function TActiveChat.Get_DropTarget: WordBool;
begin
  Result := DropTarget;
end;

function TActiveChat.Get_Enabled: WordBool;
begin
  Result := Enabled;
end;

function TActiveChat.Get_Font: IFontDisp;
begin
  GetOleFont(Font, Result);
end;

function TActiveChat.Get_HelpFile: WideString;
begin
  Result := WideString(HelpFile);
end;

function TActiveChat.Get_HelpKeyword: WideString;
begin
  Result := WideString(HelpKeyword);
end;

function TActiveChat.Get_HelpType: TxHelpType;
begin
  Result := Ord(HelpType);
end;

function TActiveChat.Get_KeyPreview: WordBool;
begin
  Result := KeyPreview;
end;

function TActiveChat.Get_PixelsPerInch: Integer;
begin
  Result := PixelsPerInch;
end;

function TActiveChat.Get_PrintScale: TxPrintScale;
begin
  Result := Ord(PrintScale);
end;

function TActiveChat.Get_Scaled: WordBool;
begin
  Result := Scaled;
end;

function TActiveChat.Get_Visible: WordBool;
begin
  Result := Visible;
end;

function TActiveChat.Get_VisibleDockClientCount: Integer;
begin
  Result := VisibleDockClientCount;
end;

procedure TActiveChat._Set_Font(var Value: IFontDisp);
begin
  SetOleFont(Font, Value);
end;

procedure TActiveChat.ActivateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnActivate;
end;

procedure TActiveChat.ClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnClick;
end;

procedure TActiveChat.CreateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnCreate;
end;

procedure TActiveChat.DblClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDblClick;
end;

procedure TActiveChat.DeactivateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDeactivate;
end;

procedure TActiveChat.DestroyEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDestroy;
end;

procedure TActiveChat.KeyPressEvent(Sender: TObject; var Key: Char);
var
  TempKey: Smallint;
begin
  TempKey := Smallint(Key);
  if FEvents <> nil then FEvents.OnKeyPress(TempKey);
  Key := Char(TempKey);
end;

procedure TActiveChat.PaintEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnPaint;
end;

procedure TActiveChat.Set_AutoScroll(Value: WordBool);
begin
  AutoScroll := Value;
end;

procedure TActiveChat.Set_AutoSize(Value: WordBool);
begin
  AutoSize := Value;
end;

procedure TActiveChat.Set_AxBorderStyle(Value: TxActiveFormBorderStyle);
begin
  AxBorderStyle := TActiveFormBorderStyle(Value);
end;

procedure TActiveChat.Set_Caption(const Value: WideString);
begin
  Caption := TCaption(Value);
end;

procedure TActiveChat.Set_Color(Value: OLE_COLOR);
begin
  Color := TColor(Value);
end;

procedure TActiveChat.Set_Cursor(Value: Smallint);
begin
  Cursor := TCursor(Value);
end;

procedure TActiveChat.Set_DoubleBuffered(Value: WordBool);
begin
  DoubleBuffered := Value;
end;

procedure TActiveChat.Set_DropTarget(Value: WordBool);
begin
  DropTarget := Value;
end;

procedure TActiveChat.Set_Enabled(Value: WordBool);
begin
  Enabled := Value;
end;

procedure TActiveChat.Set_Font(const Value: IFontDisp);
begin
  SetOleFont(Font, Value);
end;

procedure TActiveChat.Set_HelpFile(const Value: WideString);
begin
  HelpFile := String(Value);
end;

procedure TActiveChat.Set_HelpKeyword(const Value: WideString);
begin
  HelpKeyword := String(Value);
end;

procedure TActiveChat.Set_HelpType(Value: TxHelpType);
begin
  HelpType := THelpType(Value);
end;

procedure TActiveChat.Set_KeyPreview(Value: WordBool);
begin
  KeyPreview := Value;
end;

procedure TActiveChat.Set_PixelsPerInch(Value: Integer);
begin
  PixelsPerInch := Value;
end;

procedure TActiveChat.Set_PrintScale(Value: TxPrintScale);
begin
  PrintScale := TPrintScale(Value);
end;

procedure TActiveChat.Set_Scaled(Value: WordBool);
begin
  Scaled := Value;
end;

procedure TActiveChat.Set_Visible(Value: WordBool);
begin
  Visible := Value;
end;

function TActiveChat.Get_LineCount: Integer;
begin
  Result:=Editor1.Lines.Count;
end;

function TActiveChat.Get_Lines(Index: Integer): WideString;
begin
 Result:=Editor1.Lines[Index];
end;

procedure TActiveChat.AddLine(const Text: WideString; Color: Integer);
begin
  Editor1.Add(Text,Color);
end;

procedure TActiveChat.Set_Lines(Index: Integer; const Value: WideString);
begin
 Editor1.Lines[Index]:=Value;
end;

function TActiveChat.Get_Text: WideString;
begin
  Result := WideString(Editor1.Lines.Text);
end;

procedure TActiveChat.Set_Text(const Value: WideString);
begin
  Editor1.Lines.Text := TCaption(Value);
end;

initialization
  TActiveFormFactory.Create(
    ComServer,
    TActiveFormControl,
    TActiveChat,
    Class_ActiveChat,
    1,
    '',
    OLEMISC_SIMPLEFRAME or OLEMISC_ACTSLIKELABEL,
    tmApartment);
end.
