{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}
unit EditFrame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ShellAPI, Menus;

type
  TLink=record
   Rect:TRect;
   caption:string;
  end;

  TEditor = class(TFrame)
    PaintBox1: TPaintBox;
    Image1: TImage;
    PopupMenu1: TPopupMenu;
    Copier1: TMenuItem;
    N1: TMenuItem;
    Slectionnertout1: TMenuItem;
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FrameResize(Sender: TObject);
    procedure PaintBox1DblClick(Sender: TObject);
    procedure Copier1Click(Sender: TObject);
    procedure Slectionnertout1Click(Sender: TObject);
    procedure FrameEnter(Sender: TObject);
    procedure FrameExit(Sender: TObject);
  private
    { Private declarations }
    fLines:TStringList;
    fLinks:array of TLink;
    fLink :integer;
    fSelect:TRect;
    fSelMax:TPoint;
    fSelRect:TRect;
    fSelected :boolean;
    mx,my,mm  :integer;
    procedure Select(Visible:boolean);
    procedure OnChange(Sender:TObject);
    procedure SetLines(Value:TStringList);
    procedure AddLink(x,y:integer; s:string);
  public
    { Public declarations }
    Constructor Create(AOwner:TComponent); override;
    Destructor Destroy; override;
    procedure Add(s:string; color:integer);
    Property Lines:TStringList read fLines write SetLines;
  end;

Const
 Smiles:array[0..9,0..1] of char=(
  ':)',':(',':]',':}',';(',';)',':D',':',':o','8)'
 );
 
implementation

{$R *.dfm}

uses
 ClipBrd;

Const
 StopChar=[' ','[',']','(',')','<','>'];

Constructor TEditor.Create(AOwner:TComponent);
 begin
  inherited;
  fLines:=TStringList.Create;
  fLines.OnChange:=OnChange;
 end;

Destructor TEditor.Destroy;
 begin
  fLines.Free;
  inherited;
 end;

procedure TEditor.OnChange(Sender:TObject);
 begin
  fSelMax.Y:=fLines.Count-1;
  if fSelMax.Y>=0 then fSelMax.X:=Length(fLines[fSelMax.Y]) else fSelMax.X:=-1;
  FrameResize(Self);
  PaintBox1.Invalidate;
 end;

procedure TEditor.SetLines(Value:TStringList);
 begin
  fLines.Assign(Value);
 end;

procedure TEditor.Add(s:string; color:integer);
 begin
  fLines.AddObject(s,TObject(color))
 end;

procedure TEditor.PaintBox1Paint(Sender: TObject);
var
 i,j,k,y:integer;
 s:string;
begin
 with PaintBox1.Canvas do begin
  Brush.Style:=bsClear;
  fLinks:=nil;
  y:=0;
  for i:=0 to fLines.Count-1 do begin
   if y+PaintBox1.Top>=-15 then begin
    s:=fLines[i];
    Font.Color:=integer(fLines.Objects[i]);
    TextOut(0,y,s);
    for j:=1 to Length(s)-1 do begin
    // Smileys
     for k:=Low(Smiles) to High(Smiles) do begin
      if (s[j]=Smiles[k,0])
      and(s[j+1]=Smiles[k,1]) then
       CopyRect(
        Rect(8*(j-1),y,8*(j-1)+16,y+16),
        Image1.Picture.Bitmap.Canvas,
        Rect(16*k,0,16*(k+1),16)
       );
     end;
    // les liens
     if (j>1)and(s[j]='@') then AddLink(j,i,s);
     if (s[j]=':')and(s[j+1]='/') then AddLink(j,i,s);
     if (s[j]='w')and(s[j+1]='w') then AddLink(j,i,s);
     if (s[j]='.')and(s[j+1]='f') then AddLink(j,i,s);
     if (s[j]='.')and(s[j+1]='c') then AddLink(j,i,s);
     if (s[j]='.')and(s[j+1]='o') then AddLink(j,i,s);
    end;
   end;
   inc(y,16);
   if y+PaintBox1.Top>Height then break;
  end;
  Font.Color:=clBlue;
  Font.Style:=[fsUnderline];
  for i:=0 to Length(fLinks)-1 do begin
   with fLinks[i] do TextOut(rect.left,rect.top,caption);
  end;
  fSelected:=False;
  Select(True);
 end;
end;

procedure TEditor.Select(Visible:boolean);
var
 r:TRect;
begin
 if fSelected=Visible then exit;
 fSelected:=Visible;
 with PaintBox1.Canvas do begin
  if (fSelect.Top<fSelect.Bottom)
  or((fSelect.Top=fSelect.Bottom)and(fSelect.Left<fSelect.Right)) then begin
   fSelRect:=fSelect;
  end else begin
   fSelRect.Left:=fSelect.Right;
   fSelRect.Top:=fSelect.Bottom;
   fSelRect.Right:=fSelect.Left;
   fSelRect.Bottom:=fSelect.Top;
  end;
  r.Left:=8*fSelRect.Left;
  r.Top:=16*fSelRect.Top;
  r.Right:=8*fSelRect.Right;
  r.Bottom:=16*fSelRect.Bottom;
  if r.Top=r.Bottom then
   InvertRect(Handle,Rect(r.Left,r.Top,r.Right,r.Top+16))
  else begin
   InvertRect(Handle,Rect(r.Left,r.Top,Width,r.Top+16));
   InvertRect(Handle,Rect(0,r.Bottom,r.Right,r.Bottom+16));
  end;
  if r.Top+16<r.Bottom then InvertRect(Handle,Rect(0,r.Top+16,Width,r.Bottom));
  {
  if fSelLast>fSelFirst then begin
   InvertRect(Handle,Rect(0,fSelLast*16,8*fSelRight,(fSelLast+1)*16));
  end;
  }
 end;
end;

procedure TEditor.AddLink(x,y:integer; s:string);
 var
  i:integer;
  z:integer;
 begin
  i:=Length(fLinks);
  SetLength(fLinks,i+1);

  z:=x;
  while (x>1)and not (s[x-1] in StopChar) do dec(x);
  while (z<length(s))and not(s[z+1] in StopChar) do inc(z);

  with fLinks[i] do begin
   caption:=copy(s,x,z-x+1);
   rect.top:=16*y;
   rect.left:=8*(x-1);
   rect.right:=rect.left+8*length(caption);
   rect.bottom:=rect.top+16;
  end;
 end;

procedure TEditor.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
 l,r,i:integer;
begin
 if mm=1 then begin
  L:=y div 16; if L>=fSelMax.y then L:=fSelMax.y;
  R:=x div 8;  if (L=fSelMax.y) and (R>fSelMax.x) then R:=fSelMax.x;
  if (fSelect.Bottom<>L)or(fSelect.Right<>R) then begin
   Select(False);
   fSelect.Bottom:=L;
   fSelect.Right:=R;
   Select(True);
   //PaintBox1.Invalidate;
  end;
 end;
 for i:=0 to Length(fLinks)-1 do begin
  with fLinks[i] do begin
   if (x>=rect.left)and(y>=rect.top)and(x<=rect.right)and(y<=rect.bottom) then begin
    if fLink<>i then begin
     fLink:=i;
     Cursor:=crHandPoint;
    end;
    exit;
   end;
  end;
 end;
 if fLink>=0 then begin
  Cursor:=crDefault;
  fLink:=-1;
 end;
end;

procedure TEditor.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 mx:=x;
 my:=y;
 if mm<0 then mm:=0 else mm:=ord(Button)+1;
 if mm=1 then begin
  Select(False);
  if fLink>=0 then begin
   fSelect:=fLinks[fLink].Rect;
   fSelect.Top:=fSelect.Top div 16;
   fSelect.Left:=fSelect.Left div 8;
   fSelect.Right:=fSelect.Right div 8;
   fSelect.Bottom:=fSelect.Top;
   Select(True);
  end else begin
   fSelect.Top:=y div 16;
   fSelect.Left :=x div 8;
   if fSelect.Top>=fSelMax.y then fSelect.Top:=fSelMax.y;
   if (fSelect.Top=fSelMax.y) and (fSelect.Left>fSelMax.x) then fSelect.Left:=fSelMax.x;
   fSelect.Bottom:=fSelect.Top;
   fSelect.Right:=fSelect.Left;
  end;
 end;
end;

procedure TEditor.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 mm:=0;
end;

procedure TEditor.FrameResize(Sender: TObject);
var
 w,h,i,j:integer;
begin
 w:=0;
 for i:=0 to fLines.count-1 do begin
  j:=Length(fLines[i]);
  if j>w then w:=j;
 end;
 w:=8*w;
 h:=16*fLines.Count;
 if w<ClientWidth then w:=ClientWidth;
 if h<ClientHeight then h:=ClientHeight;
 PaintBox1.Height:=h;
 PaintBox1.Width:=w;
 VertScrollBar.Position:=PaintBox1.Height;
end;

procedure TEditor.PaintBox1DblClick(Sender: TObject);
var
 s:string;
begin
 if fLink>=0 then begin
  s:=fLinks[fLink].Caption;
  if (pos('@',s)>0) then begin
   if (pos(':',s)=0) then s:='mailto:'+s;
  end else begin
   if (pos('://',s)=0) then s:='http://'+s;
  end;
  ShellExecute(Handle,nil,PChar(s),nil,nil,sw_shownormal);
 end;
 mm:=-1;
end;

procedure TEditor.Copier1Click(Sender: TObject);
var
 i:integer;
 s:string;
begin
 s:='';
 if fSelected then begin
  if fSelRect.Top=fSelRect.Bottom then begin
   s:=Copy(fLines[fSelRect.Top],fSelRect.Left+1,fSelRect.Right-fSelRect.Left);
  end else begin
   s:=fLines[fSelRect.Top];
   Delete(s,1,fSelRect.Left);
   for i:=fSelRect.Top+1 to fSelRect.Bottom-1 do s:=s+#13#10+fLines[i];
   s:=s+#13#10+Copy(fLines[fSelRect.Bottom],1,fSelRect.Right);
  end;
  clipboard.AsText:=s;
 end;
end;

procedure TEditor.Slectionnertout1Click(Sender: TObject);
begin
 Select(False);
 fSelect.Left:=0;
 fSelect.Top:=0;
 fSelect.Right:=fSelMax.x;
 fSelect.Bottom:=fSelMax.y;
 Select(True);
end;

procedure TEditor.FrameEnter(Sender: TObject);
begin
 Select(True);
end;

procedure TEditor.FrameExit(Sender: TObject);
begin
 Select(False);
end;

end.
