{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{$DEFINE INTERFACE}

Type
{$IFDEF INTERFACE}
 IDirectDraw=interface
  procedure _Compact;
  procedure _CreateClipper;
  procedure _CreatePalette;
  procedure _CreateSurface;
  procedure _DuplicateSurface;
  procedure _EnumDisplayModes;
  procedure _EnumSurfaces;
  procedure _FlipToGDISurface;
  procedure _GetCaps;
  procedure _GetDisplayMode;
  procedure _GetFourCCCodes;
  procedure _GetGDISurface;
  procedure _GetMonitorFrequency;
  procedure _GetScanLine;
  procedure _GetVerticalBlankStatus;
  procedure _Initialize;
  function RestoreDisplayMode:integer; stdcall;
  procedure _SetCooperativeLevel;
  function SetDisplayMode(Width,Height,BPP:DWORD):HResult; stdcall;
 end;
{$ELSE}
 IUnknown=^PUnknown;
 PUnknown=^TUnknown;
 TUnknown=record
  QueryInterface:function(const Self:IUnknown; const IID:TGUID; out obj):integer; stdcall;
  AddRef        :function(const Self:IUnknown):integer; stdcall;
  Release       :function(const Self:IUnknown):integer; stdcall;
 end;

 IDirectDraw=^PDirectDraw;
 PDirectDraw=^TDirectDraw;
 TDirectDraw=record
 // IUnknown
  Unknown:TUnknown;
 // IDirectDraw
  _Compact:pointer;
  _CreateClipper:pointer;
  _CreatePalette:pointer;
  _CreateSurface:pointer;
  _DuplicateSurface:pointer;
  _EnumDisplayModes:pointer;
  _EnumSurfaces:pointer;
  _FlipToGDISurface:pointer;
  _GetCaps:pointer;
  _GetDisplayMode:pointer;
  _GetFourCCCodes:pointer;
  _GetGDISurface:pointer;
  _GetMonitorFrequency:pointer;
  _GetScanLine:pointer;
  _GetVerticalBlankStatus:pointer;
  _Initialize:pointer;
  RestoreDisplayMode:function(const Self:IDirectDraw):integer; stdcall;
  _SetCooperativeLevel:pointer;
  SetDisplayMode:function(const Self:IDirectDraw; Width,Height,BPP:DWORD):HResult; stdcall;
 end;
{$ENDIF}

function DirectDrawCreate(
     GUID:PGUID;
 out DD:IDirectDraw;
     Unknown:IUnknown
):integer; stdcall; external 'DDRAW.DLL';

var
 DD:IDirectDraw;

procedure TForm1.FormCreate(Sender: TObject);
begin
 DirectDrawCreate(nil,DD,nil);
{$IFDEF INTERFACE}
 DD.SetDisplayMode(640,480,32);
{$ELSE}
 DD^^.SetDisplayMode(DD,640,480,32);
{$ENDIF}
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
{$IFDEF INTERFACE}
 DD.RestoreDisplayMode;
{$ELSE}
 DD^^.RestoreDisplayMode(DD);
 DD^^.Unknown.Release(IUnknown(DD));
{$ENDIF}
end;

end.
