{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ActiveX;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
    function TypeName(Element:TElemDesc):string;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
 ComObj;

// le CLSID de PDF
const
 PDF:TGUID='{CA8A9780-280D-11CF-A24D-444553540000}';

procedure TForm1.FormCreate(Sender: TObject);
var
 Unknown :IUnknown;
 Dispatch:IDispatch;
 i,Count  :integer;
 TypeInfo :ITypeInfo;
 TypeAttr :PTypeAttr;
 v,f      :integer;
 FuncDesc :PFuncDesc;
 VarDesc  :PVarDesc;
 Names    :TBStrList;
 cNames   :integer;
 s        :string;
 p        :integer;
begin
// Interface de l'ActiveX PDF
 OleCheck(CoCreateInstance(PDF,nil,CLSCTX_INPROC_SERVER or CLSCTX_LOCAL_SERVER,IUnknown,Unknown));
// dispinterface
 Unknown.QueryInterface(IDispatch,Dispatch);
 Memo1.Text:='IPDF = dispinterface';
// nombre d'informations
 Dispatch.GetTypeInfoCount(Count);
// pour chaque information
 for i:=0 to Count-1 do begin
 // rcuprer les informations
  Dispatch.GetTypeInfo(i,0,TypeInfo);
 // et les attributs
  TypeInfo.GetTypeAttr(TypeAttr);
 // s'il sagit d'un dispatch
  if TypeAttr.typekind=TKIND_DISPATCH then begin
  // rcuprer le DIID
   Memo1.Lines.Add(' ['+GUIDToString(TypeAttr.guid)+']');
  // la liste des variables,
   for v:=0 to TypeAttr.cVars-1 do begin
    TypeInfo.GetVarDesc(v,VarDesc);
    TypeInfo.GetNames(VarDesc.memid,@Names,1,cNames);
    if cNames>0 then begin
     s:=Names[0];
     Memo1.Lines.Add(' property '+s+TypeName(VarDesc.elemdescVar)+' dispid '+IntToStr(VarDesc.memid)+';');
    end;
    TypeInfo.ReleaseVarDesc(VarDesc);
   end;
  // et la liste des mthodes
   for f:=0 to TypeAttr.cFuncs-1 do begin
    TypeInfo.GetFuncDesc(f,FuncDesc);
    TypeInfo.GetNames(FuncDesc.memid,@Names,FuncDesc.cParams+1,cNames);
    if cNames>0 then begin
     s:=Names[0];
     if cNames>1 then begin
      s:=s+'(';
      for p:=1 to cNames-2 do s:=s+Names[p]+TypeName(FuncDesc.lprgelemdescParam[p-1])+';';
      s:=s+Names[cNames-1]+TypeName(FuncDesc.lprgelemdescParam[cNames-2])+')';
     end;
     if FuncDesc.elemdescFunc.tdesc.vt=VT_VOID then begin
      s:=' procedure '+s;
     end else begin
      s:=' function '+s+TypeName(FuncDesc.elemdescFunc);
     end;
     Memo1.Lines.Add(s+'; dispid '+IntToStr(FuncDesc.memid)+';');
    end;
    TypeInfo.ReleaseFuncDesc(FuncDesc);
   end;
  end;
  TypeInfo.ReleaseTypeAttr(TypeAttr);
 end;
 Memo1.Lines.Add('end;');
end;

function TForm1.TypeName(Element:TElemDesc):string;
 begin
  case Element.tdesc.vt of
   VT_I4   : result:=':Integer';
   VT_R4   : result:=':Single';     
   VT_BOOL : result:=':WordBool';
   VT_BSTR : result:=':WideString';
   else result:='{'+IntToStr(Element.tdesc.vt)+'}';
  end;
 end;

end.
