{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit Unit2;

interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;


 Type

   TCDComponent = Class;

   TMP3Item = Class(TCollectionItem)
    private
     ftitre : string;
     fgroupe : string;
     fannee : integer;
     procedure SetAnnee(value:integer);
     procedure SetGroupe(value:string);
     procedure SetTitre(value:string);
    protected
     function GetDisplayName: string; override;
    public
     constructor Create(Collection: TCollection); override;
     procedure Assign(Source: TPersistent); override;
    published
     property Titre : string read ftitre write Settitre;
     property Groupe: string read fgroupe write Setgroupe;
     property annee:  integer read fannee  write setannee;
    end;

   TMP3Collection = Class(Tcollection)
    private
     fCDcomp : TCDComponent;
     function GetItem(index:integer):TMP3Item;
     procedure SetItem(index:integer;Value:TMP3Item);
    protected
     function GetOwner:TPersistent; override;
     procedure Update(Item: TCollectionItem); override;
    public
     constructor create(CD:TCDComponent);
     function Add : TMP3Item;
     property Items[index:integer] : TMP3Item read GetItem write SetItem; default;
    end;

   TCDComponent = Class(Tcomponent)
    private
     ftitrecd:string;
     fItems : TMP3Collection;
     procedure setItems(value:TMP3Collection);
    public
     constructor create(AOwner:Tcomponent); override;
     destructor destroy; override;
     procedure ListeModifiee(Item:TMP3Item);
    published
     property TitreCD : string read ftitrecd write ftitrecd;
     property Items : TMP3Collection read fItems write SetItems;
    end;

implementation

// TMP3Item

constructor TMP3Item.Create(Collection: TCollection);
begin
 inherited create(Collection);
 fannee := 2000;
end;

procedure TMP3Item.SetAnnee(value:integer);
begin
 if (value<>fannee) and (value <2003) then
 begin
  fannee := value;
  Changed(false);
 end;
end;

procedure TMP3Item.SetGroupe(value:string);
begin
 if value<>fgroupe then
  begin
   fgroupe:=value;
   changed(false);
  end;
end;

procedure TMP3Item.SetTitre(value:string);
begin
 if value<>ftitre then
  begin
   ftitre := value;
   changed(false);
  end;
end;

function TMP3Item.GetDisplayName: string;
begin
 if titre<>'' then
  result := Titre+' ('+inttostr(fannee)+')' else
  result := inherited GetDisplayName;
end;

procedure TMP3Item.Assign(Source: TPersistent);
begin
  if Source is TMP3Item then
  begin
    Titre  := TMP3Item(Source).Titre;
    Groupe := TMP3Item(Source).Groupe;
    Annee  := TMP3Item(Source).Annee;
    Exit;
  end;
  inherited Assign(Source);
end;

// TMP3Collection


function TMP3Collection.GetItem(index:integer):TMP3Item;
begin
 Result := TMP3Item(inherited GetItem(Index));
end;

procedure TMP3Collection.SetItem(index:integer;Value:TMP3Item);
begin
 inherited SetItem(Index, Value);
end;

function TMP3Collection.GetOwner:TPersistent;
begin
 Result := FCDComp;
end;

constructor TMP3Collection.create(CD:TCDComponent);
begin
 inherited create(TMP3Item);
 fCDComp := CD;
end;

function TMP3Collection.Add : TMP3Item;
begin
 Result := TMP3Item(inherited Add);
end;

procedure TMP3Collection.Update(Item: TCollectionItem);
begin
 FCDComp.ListeModifiee(TMP3item(item));
end;

// TCDComponent

procedure TCDComponent.setItems(value:TMP3Collection);
begin
 FItems.Assign(Value);
end;

constructor TCDComponent.create(AOwner:Tcomponent);
begin
 inherited Create(AOwner);
 FItems := TMP3Collection.Create(Self);
end;

destructor TCDComponent.destroy;
begin
 FItems.Free;
 inherited Destroy;
end;

procedure TCDComponent.ListeModifiee(Item:TMP3Item);
begin
 if Item=nil then Showmessage('Toute la liste a t modifie')
  else Showmessage('L''lment '+Item.GetDisplayName+' a t modifi');
end;

end.
