{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

{-----------------------------------------------------------------------------
 Unit Name: LivreD7TimePanel
 Author:    Olivier Dahan odahan@e-naxos.com
 Purpose:   D7-OD 
 History:   April, 2002 V 1.0
-----------------------------------------------------------------------------}

unit LivreD7TimePanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, ExtCtrls,
  Dialogs;

type
  tLivreD7TimePanel = class(tcustompanel)
  private
    { Dclarations prives }
    ftimer : TTimer;
    fStampFormat : string;
    procedure SetStampFormat(value:string);
    procedure SetInterval(value:integer);
    function GetInterval:integer;
    procedure InternalOnTimer(sender:tobject);
  protected
    { Dclarations protges }
    Procedure CreateWnd; override;
  public
    { Dclarations publiques }
    constructor create(aowner:tcomponent); override;
    destructor destroy; override;
  published
    { Dclarations publies }
    procedure AboutBox;
    property StampFormat : string read fStampFormat write SetStampFormat;
    property Interval : integer read GetInterval write SetInterval default 1000;
    property Font;
    property Height default 22;
  end;

// procedure Register;  inutile en dynamique mais laisse la possibilit
                     // de charger le composant dans la palette .. un jour..

implementation

{procedure Register;
begin
  RegisterComponents('Livre D7', [tLivreD7TimePanel]);
end; }


{-----------------------------------------------------------------------------
  Procedure: tLivreD7TimePanel.create
  Author:    od
  Date:      26-avr.-2002
  Arguments: aowner:tcomponent
  Result:    None
  Usage:     Constructeur de la classe
-----------------------------------------------------------------------------}
Constructor tLivreD7TimePanel.create(aowner:tcomponent);
begin
 Inherited create(aowner);
 ControlStyle := ControlStyle - [csAcceptsControls,csSetCaption];
 fStampFormat := LongDateFormat + ' '+ LongTimeFormat;
 Alignment := tacenter;
 ftimer:=TTimer.create(self);
 ftimer.Interval := 1000;
 ftimer.OnTimer := InternalOnTimer;
 ftimer.Enabled := true;
 InternalOnTimer(nil);
end;

{-----------------------------------------------------------------------------
  Procedure: tLivreD7TimePanel.CreateWnd
  Author:    od
  Date:      26-avr.-2002
  Arguments: None
  Result:    None
  Usage:     Modifier des proprits visuelles une fois le parent fix
-----------------------------------------------------------------------------}
Procedure tLivreD7TimePanel.CreateWnd;
begin
 inherited CreateWnd;
 Height := 22;
 Width := canvas.TextWidth(FormatDateTime(fStampFormat,now))+10;
end;

{-----------------------------------------------------------------------------
  Procedure: tLivreD7TimePanel.destroy
  Author:    od
  Date:      26-avr.-2002
  Arguments: None
  Result:    None
  Usage:     Destructeur
-----------------------------------------------------------------------------}
Destructor tLivreD7TimePanel.destroy;
begin
 ftimer.Enabled:=false;
 ftimer.Free;
 Inherited destroy;
end;

{-----------------------------------------------------------------------------
  Procedure: tLivreD7TimePanel.InternalOnTimer
  Author:    od
  Date:      26-avr.-2002
  Arguments: sender:tobject
  Result:    None
  Usage:     OnTimer interne, mise  jour affichage
-----------------------------------------------------------------------------}
procedure tLivreD7TimePanel.InternalOnTimer(sender:tobject);
begin
 caption := FormatDateTime(fStampFormat,now);
end;

{-----------------------------------------------------------------------------
  Procedure: tLivreD7TimePanel.SetInterval
  Author:    od
  Date:      26-avr.-2002
  Arguments: value:integer
  Result:    None
  Usage:     setter de la proprit Interval
-----------------------------------------------------------------------------}
procedure tLivreD7TimePanel.SetInterval(value:integer);
begin
 if Interval<>value then
  begin
   ftimer.Enabled:=false;
   ftimer.Interval := value;
   ftimer.Enabled:=true;
  end;
end;

{-----------------------------------------------------------------------------
  Procedure: tLivreD7TimePanel.GetInterval
  Author:    od
  Date:      26-avr.-2002
  Arguments: None
  Result:    integer
  Usage:     getter de la proprit Interval
-----------------------------------------------------------------------------}
function tLivreD7TimePanel.GetInterval:integer;
begin
 Result := ftimer.Interval;
end;

{-----------------------------------------------------------------------------
  Procedure: tLivreD7TimePanel.SetStampFormat
  Author:    od
  Date:      26-avr.-2002
  Arguments: value:string
  Result:    None
  Usage:     setter de la proprit StampFormat
-----------------------------------------------------------------------------}
procedure tLivreD7TimePanel.SetStampFormat(value:string);
begin
 if value<>fStampFormat then
  begin
   ftimer.Enabled:=false;
   fStampFormat:=value;
   InternalOnTimer(nil);
   ftimer.Enabled:=true;
  end;
end;

{-----------------------------------------------------------------------------
  Procedure: tLivreD7TimePanel.AboutBox
  Author:    od
  Date:      28-avr.-2002
  Arguments: None
  Result:    None
  Usage:     Pour dmonstration de l'appel d'une mthode
-----------------------------------------------------------------------------}

procedure tLivreD7TimePanel.AboutBox;
begin
 Showmessage('Composant de test'#13#10'Livre Delphi 7'#13#10'Chargement dynamique de package'#13#10'(c) 2002 OD');
end;

// Nous ajoutons ce code pour enregistrer la classe
// automatiquement lorsque le package appelant sera charg
Initialization
 RegisterClass(tLivreD7TimePanel);
Finalization
 UnRegisterClass(tLivreD7TimePanel);
end.
