{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

{-----------------------------------------------------------------------------
 Unit Name: uUsesPack
 Author:    od
 Purpose:   utiliser le package dynamique cr pour l'exemple
 History:   April, 2002 V 1.0
-----------------------------------------------------------------------------}

unit uUsesPack;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, typinfo;

type
  TForm1 = class(TForm)
    btnLoadPackage: TButton;
    btnUnloadPackage: TButton;
    Label1: TLabel;
    Label2: TLabel;
    bntCreateComponent: TButton;
    btnDestroyComponent: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Label5: TLabel;
    btnLire: TButton;
    btnEcrire: TButton;
    btnCallAboutBox: TButton;
    procedure btnLoadPackageClick(Sender: TObject);
    procedure btnUnloadPackageClick(Sender: TObject);
    procedure bntCreateComponentClick(Sender: TObject);
    procedure btnDestroyComponentClick(Sender: TObject);
    procedure btnCallAboutBoxClick(Sender: TObject);
    procedure btnLireClick(Sender: TObject);
    procedure btnEcrireClick(Sender: TObject);
  private
    { Dclarations prives }
    fPlugin : HModule;
    fObjet  : TComponent;
    procedure UpdateState;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{-----------------------------------------------------------------------------
  Procedure: TForm1.btnLoadPackageClick
  Author:    od
  Date:      28-avr.-2002
  Arguments: Sender: TObject
  Result:    None
  Usage:     Charge le package
-----------------------------------------------------------------------------}

procedure TForm1.btnLoadPackageClick(Sender: TObject);
begin
 if fPlugin=0 then // si le plugin n'est pas encore charg
  fPlugin := LoadPackage('ODTimePanelD7.bpl'); // chargement
 UpdateState; // mise  jour de l'affichage
end;

{-----------------------------------------------------------------------------
  Procedure: TForm1.btnUnloadPackageClick
  Author:    od
  Date:      28-avr.-2002
  Arguments: Sender: TObject
  Result:    None
  Usage:     Dcharge le package
-----------------------------------------------------------------------------}

procedure TForm1.btnUnloadPackageClick(Sender: TObject);
begin
 if fPlugin<>0 then // si le plugin est dj charg
  begin
   // commencer par dtruire tous les objets instancis
   // en utilisant des classes du package
   if assigned(fObjet) then FreeAndNil(fObjet);
   UnloadPackage(fPlugin); // dchargement
   fPlugin := 0;
  end;
 UpdateState;
end;

{-----------------------------------------------------------------------------
  Procedure: Tform1.UpdateState
  Author:    od
  Date:      28-avr.-2002
  Arguments: None
  Result:    None
  Usage:     Mettre  jour l'affichage (charg/on charg, info package)
-----------------------------------------------------------------------------}

procedure Tform1.UpdateState;
begin
 if fPlugin=0 then label2.caption:='[non charg]'
  else begin
   label2.caption :='Module Charg';
   // affichage du titre du package
   // cette fonction est "stand alone" et tente elle-mme de
   // charger le package et le libre ensuite ce qui ne gne pas le fonctionnement
   label3.caption := GetpackageDescription('ODTimePanelD7.bpl');
  end;
end;

{-----------------------------------------------------------------------------
  Procedure: TForm1.bntCreateComponentClick
  Author:    od
  Date:      28-avr.-2002
  Arguments: Sender: TObject
  Result:    None
  Usage:     Instancier le composant du package
-----------------------------------------------------------------------------}

procedure TForm1.bntCreateComponentClick(Sender: TObject);
var Classe : TPersistentClass;
begin
 if assigned(fObjet) then exit; // si l'objet existe dj on sort..
 Classe := GetClass('tLivreD7TimePanel'); // on obtient la rfrence de classe
 If Classe <> Nil then // si on a obtenu une rfrence valide
  begin
   fObjet := TComponentClass(Classe).Create(self); // instancier le composant
   TWinControl(fObjet).Parent := self; // le transtypage permet d'accder aux
   TWinControl(fObjet).Left   := 10;   // proprits des contrles fentrs
   TWinControl(fObjet).Top    := 104;  // absente dans TComponent
  end else showmessage('Ne trouve pas la classe');
end;

{-----------------------------------------------------------------------------
  Procedure: TForm1.btnDestroyComponentClick
  Author:    od
  Date:      28-avr.-2002
  Arguments: Sender: TObject
  Result:    None
  Usage:     Dtruire l'instance du composant
-----------------------------------------------------------------------------}

procedure TForm1.btnDestroyComponentClick(Sender: TObject);
begin
 FreeAndNil(fObjet); // libration de l'objet et raz du pointeur
end;

{-----------------------------------------------------------------------------
  Procedure: TForm1.btnCallAboutBoxClick
  Author:    od
  Date:      28-avr.-2002
  Arguments: Sender: TObject
  Result:    Chercher et appelle la mthode AboutBox publie dans le composant
-----------------------------------------------------------------------------}

procedure TForm1.btnCallAboutBoxClick(Sender: TObject);
var p:procedure;
begin
 if fObjet=nil then exit;
 p:=fObjet.MethodAddress('AboutBox');
 if assigned(p) then p else showmessage('Ne trouve pas "AboutBox"');
end;

{-----------------------------------------------------------------------------
  Procedure: TForm1.btnLireClick
  Author:    od
  Date:      28-avr.-2002
  Arguments: Sender: TObject
  Result:    Lit la valeur de la proprit StampFormat du composant
-----------------------------------------------------------------------------}

procedure TForm1.btnLireClick(Sender: TObject);
var v:variant;
begin
if isPublishedprop(fObjet,'StampFormat') then
 v:= GetPropValue(fObjet,'StampFormat');
 edit1.text := v;
end;

{-----------------------------------------------------------------------------
  Procedure: TForm1.btnEcrireClick
  Author:    od
  Date:      28-avr.-2002
  Arguments: Sender: TObject
  Result:    Modifie la valeur de la proprit StampFormat
-----------------------------------------------------------------------------}

procedure TForm1.btnEcrireClick(Sender: TObject);
var v:variant;
begin
 v:=Edit1.Text;
 SetPropValue(fObjet,'StampFormat',v);
end;

end.
