{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit Configs;

interface

uses
    SysUtils, Classes, Controls, StdCtrls;

Type
 TConfiguration=class(TComponent)
  function GetPath:string;
  procedure SetPath(Value:string);
  function GetVersion:integer;
  procedure SetVersion(Value:integer);
  procedure Invalidate;
 published
  property Path:string read GetPath write SetPath;
  property Version:integer read GetVersion write SetVersion;
 end;

 TInfo=class(TCustomLabel)
 protected
  procedure Paint; override;
 public
  Constructor Create(AOwner:TComponent); override;
  Destructor Destroy; override;
 end;


implementation

var
 GlobalPath:string;
 GlobalVersion:integer;
 GlobalInfos:TList;

function TConfiguration.GetPath:string;
 begin
  Result:=GlobalPath;
 end;

procedure TConfiguration.SetPath(Value:string);
 begin
  GlobalPath:=Value;
  Invalidate;
 end;

function TConfiguration.GetVersion:integer;
 begin
  Result:=GlobalVersion;
 end;

procedure TConfiguration.SetVersion(Value:integer);
 begin
  GlobalVersion:=Value;
  Invalidate;
 end;

procedure TConfiguration.Invalidate;
 var
  i:integer;
 begin
  for i:=0 to GlobalInfos.Count-1 do TInfo(GlobalInfos[i]).Invalidate;
 end;

Constructor TInfo.Create(AOwner:TComponent);
 begin
  inherited;
  GlobalInfos.Add(Self);
 end;

Destructor TInfo.Destroy;
 begin
  GlobalInfos.Remove(Self);
  inherited;
 end;

procedure TInfo.Paint;
 begin
  Canvas.TextOut(0,0,GlobalPath+' '+IntToStr(GlobalVersion));
 end;

initialization
 GlobalInfos:=TList.Create;

finalization
 GlobalInfos.Free;

end.
