{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit Identifications;

interface

uses
  Windows, Messages, SysUtils, Classes;

type
  TIdentification = class(TComponent)
  private
   fUserName:string;
   fPassword:string;
  protected
   procedure WritePassword(Writer:TWriter);
   procedure ReadPassword(Reader:TReader);
   procedure DefineProperties(Filer:TFiler); override;
  published
   property UserName:string read fUserName write fUserName;
   property Password:string read fPassword write fPassword stored false;
  end;

procedure Register;
function XorString(Value,Key:string):string;

implementation

procedure Register;
begin
  RegisterComponents('Livre D7', [TIdentification]);
end;

function XorString(Value,Key:string):string;
 var
  i:integer;
 begin
  Result:=Value;
  for i:=1 to length(Result) do begin
   Result[i]:=chr(ord(Result[i]) xor ord(Key[i mod Length(Key)+1]));
  end;
 end;

procedure TIdentification.DefineProperties(Filer:TFiler);
 begin
  inherited;
  Filer.DefineProperty('xPassword',ReadPassword,WritePassword,Password<>'');
 end;

procedure TIdentification.WritePassword(Writer:TWriter);
 begin
  Writer.WriteString(XorString(fPassword,'DELPHI'));
 end;

procedure TIdentification.ReadPassword(Reader:TReader);
 begin
  fPassword:=XorString(Reader.ReadString,'DELPHI');
 end;

end.
