{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit PaintLists;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, StdCtrls, ExtCtrls;

Type
 TPaintList=class(TPaintBox)
 private
  fLines:TStrings;
  fOnChange:TNotifyEvent;
  procedure SetLines(Value:TStrings);
  procedure DoChange(Sender:TObject);
 protected
  Procedure Paint; override;
  procedure SetParent(AParent: TWinControl); override;
 public
  Constructor Create(AOwner:TComponent); override;
  Destructor Destroy; override;
 published
  property Lines:TStrings read fLines write SetLines;
  property OnChange:TNotifyEvent read fOnChange write fOnChange;
 end;

implementation

Constructor TPaintList.Create(AOwner:TComponent);
 begin
  inherited;
  fLines:=TStringList.Create;
  TStringList(fLines).OnChange:=DoChange;
  Font.OnChange:=DoChange;
//  Height:=Canvas.TextHeight(Caption);
 end;

Procedure TPaintList.SetParent(AParent:TWinControl);
 begin
  inherited;
  if Assigned(AParent) then Height:=Canvas.TextHeight('A');
 end;

Destructor TPaintList.Destroy;
 begin
  fLines.Free;
  inherited;
 end;

Procedure TPaintList.SetLines(Value:TStrings);
 begin
  fLines.Assign(Value);
 end;

Procedure TPaintList.DoChange(Sender:TObject);
 begin
  if Assigned(fOnChange) then fOnChange(Self);
  Invalidate;
 end;

Procedure TPaintList.Paint;
 var
  i,y:integer;
 begin
  inherited;
  with Canvas do begin
   Font.Assign(Self.Font);
   y:=0;
   for i:=0 to fLines.Count-1 do begin
    TextOut(0,y,fLines[i]);
    inc(y,TextHeight(fLines[i])+2);
   end;
  end;
 end;

end.
