{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

unit Storages;

interface

uses
  Windows, Messages, SysUtils, Classes;

type
  TStorage = class(TComponent)
  private
   fData    :TMemoryStream;
   fFileName:TFileName;
   procedure SetFileName(Value:TFileName);
  protected
   procedure WriteData(Stream:TStream);
   procedure ReadData(Stream:TStream);
   procedure DefineProperties(Filer: TFiler); override;
  public
   Constructor Create(AOwner:TComponent); override;
   Destructor Destroy; override;
   function Memory:pointer;
   function Size:integer;
  published
   property FileName:TFileName read fFileName write SetFileName stored false;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Livre D7', [TStorage]);
end;

Constructor TStorage.Create(AOwner:TComponent);
 begin
  inherited;
  fData:=TMemoryStream.Create;
 end;

Destructor TStorage.Destroy;
 begin
  fData.Free;
  inherited;
 end;

Function TStorage.Memory:pointer;
 begin
  Result:=fData.Memory;
 end;

Function TStorage.Size:integer;
 begin
  Result:=fData.Size;
 end;

Procedure TStorage.SetFileName(Value:TFileName);
 begin
  fFileName:=Value;
  fData.LoadFromFile(fFileName);
 end;

Procedure TStorage.DefineProperties(Filer:TFiler);
 begin
  inherited;
  Filer.DefineBinaryProperty('Data',ReadData,WriteData,fData.Size>0);
 end;

Procedure TStorage.WriteData(Stream:TStream);
 begin
  Stream.CopyFrom(fData,0);
 end;

Procedure TStorage.ReadData(Stream:TStream);
 begin
  fData.LoadFromStream(Stream);
 end;

end.
