{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

// Livre D7 - Editeur de proprit boolean
// OD - mai 02
// V 1.0

unit BoolEdit;

interface

uses
  windows,
  classes,
  Types,         // dfinition de TRec notamment
  ExtCtrls,      // La classe TShape se trouve l
  DesignIntf,    // les services de design
  DesignEditors, // les diteurs existants
  VCLEditors,    // dclaration des diteurs VCL
  Graphics;      // pour manipuler les graphiques

type
  // L'diteur de proprit
  TGraphBooleanProperty = class(TEnumProperty,ICustomPropertyListDrawing)
   // support de l'interface ICustomPropertyListDrawing
    procedure ListMeasureWidth(const Value: string; ACanvas: TCanvas;
      var AWidth: Integer);
    procedure ListMeasureHeight(const Value: string; ACanvas: TCanvas;
      var AHeight: Integer);
    procedure ListDrawValue(const Value: string; ACanvas: TCanvas;
      const ARect: TRect; ASelected: Boolean);
  end;

procedure Register;

implementation
uses typinfo;
{$R *.res}

var
 TrueBmp : TBitmap;
 FalseBmp: TBitmap;


procedure TGraphBooleanProperty.ListDrawValue(const Value: string;
  ACanvas: TCanvas; const ARect: TRect; ASelected: Boolean);
var
  X,Y,H,W: Integer;
  BordDroit: integer;
  ValeurBooleenne: boolean;
begin
  // calculer le bord pour laisser la place de l'image
  BordDroit := (ARect.Bottom - ARect.Top) + ARect.Left;
  with ACanvas do
	  try
	    ValeurBooleenne := Boolean(GetEnumValue(GetPropType, Value));
            // limites de l'images  dessiner
	    X := ARect.Left + 1;
	    Y := ARect.Top + 1;
	    W := BordDroit - ARect.Left - 1;
	    H := ARect.Bottom - ARect.Top - 1;
            if ValeurBooleenne then
               StretchDraw(Rect(X, Y, X+W, Y+H), Truebmp) else
               StretchDraw(Rect(X, Y, X+W, Y+H), FalseBmp);
	  finally
           // dessiner le texte
           acanvas.TextRect(Rect(BordDroit, ARect.Top, ARect.Right, ARect.Bottom),
                           BordDroit,ARect.Top,Value);
   	  end;
end;

procedure TGraphBooleanProperty.ListMeasureWidth(const Value: string;
  ACanvas: TCanvas; var AWidth: Integer);
begin
  AWidth := Awidth + Acanvas.TextWidth('W')+1; // largeur pour l'image
end;

procedure TGraphBooleanProperty.ListMeasureHeight(const Value: string; ACanvas: TCanvas;
      var AHeight: Integer);
begin
 AHeight := Acanvas.TextHeight('A')+ 1; // hauteur d'une ligne
end;


// enregistrement de l'diteur
procedure Register;
begin
  RegisterPropertyEditor(TypeInfo(Boolean), nil, '', TGraphBooleanProperty);
end;  { Register }

initialization
 // chargement des bitmaps
  Truebmp := TBitmap.Create;
  FalseBmp := TBitmap.Create;
  Truebmp.Handle := LoadBitmap(HInstance, PChar('TRUE'));
  FalseBmp.Handle := LoadBitmap(HInstance, PChar('FALSE'));
finalization
 // libration des images
  Truebmp.Free;
  FalseBmp.Free;
end.
 

