{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

{-----------------------------------------------------------------------------
 Unit Name: uCompEdit
 Author:    od
 Purpose:   Exemple de dialogue d'dition d'un composant (TShape)
 History:   Mai 2002 - V 1.0
 Note:      Le dialogue est totalement indpendant et peut fonctionner
            dans une application "normale". L'unit expose une procdure qui
            permet l'dition d'un tshape sans rien savoir des dtails.
-----------------------------------------------------------------------------}

unit uCompEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls;

type
  TFEditTShape = class(TForm)
    ListBox1: TListBox;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    ColorBox1: TColorBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    GroupBox2: TGroupBox;
    ColorBox2: TColorBox;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    Label2: TLabel;
    Edit1: TEdit;
    Label3: TLabel;
    Edit2: TEdit;
    UpDown1: TUpDown;
    Label4: TLabel;
    Edit3: TEdit;
    GroupBox3: TGroupBox;
    Shape1: TShape;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    procedure ListBox1Click(Sender: TObject);
    procedure ColorBox1Change(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure ColorBox2Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
  private
    { Dclarations prives }
    Updating : boolean;
    fSCName:String;
    procedure CenterShape;
    Procedure UpdateDisplay;
  public
    { Dclarations publiques }
    Procedure InitShape(UneForme:TShape);
    procedure CopyProps(Source,Dest:Tshape);
    property ShapeComponentName : string read fSCName write fSCName;
  end;

// La procdure  appeler pour modifier un TShape
Procedure EditTShape(LaForme:TShape);

implementation

{$R *.dfm}

// copie les proprits d'un tshape vers un autre
// la mthode Assign du TShape n'ayant pas t programme dans la VCL
procedure TFEditTShape.CopyProps(Source,Dest:Tshape);
begin
 Dest.Shape := Source.Shape;
 Dest.Pen.Assign(Source.Pen);
 Dest.Brush.Assign(Source.Brush);
 Dest.Width := Source.Width;
 Dest.Height:= Source.Height;
 Dest.Hint  := Source.Hint;
end;

// centre le tshape de simulation dans son groupbox
Procedure TFEditTShape.CenterShape;
begin
 Shape1.Top          := (GroupBox3.Height-shape1.height) div 2;
 Shape1.Left         := (GroupBox3.Width-shape1.Width) div 2;
end;

// initialise le dialogue  partir d'un tshape
Procedure TFEditTShape.InitShape(UneForme:TShape);
begin
 Edit3.Text := ShapeComponentName;
 CopyProps(UneForme,Shape1);
 UpdateDisplay;
end;

// met  jour l'affichage
Procedure TFEditTShape.UpdateDisplay;
begin
 Updating:=True; // drapeau de mise  jour en cours
 try
  Listbox1.ItemIndex  := Integer(Shape1.Shape);
  ColorBox1.Selected  := Shape1.Brush.Color;
  RadioButton2.Checked:= Shape1.Brush.Style=bsclear;
  RadioButton1.Checked:= not RadioButton2.Checked;
  ColorBox2.Selected  := Shape1.Pen.Color;
  RadioButton3.Checked:= Shape1.Brush.Style=bsclear;
  RadioButton4.Checked:= not RadioButton2.Checked;
  UpDown1.Position    := Shape1.Pen.Width;
  Edit1.Text          := Shape1.Hint;
  TrackBar1.Position  := Shape1.Height;
  TrackBar2.Position  := Shape1.Width;
  Label7.caption      := IntTostr(Shape1.Height);
  Label8.caption      := IntToStr(Shape1.Width);
  CenterShape;
 finally
  Updating := false;
 end;
end;

// slection d'une nouvelle forme
procedure TFEditTShape.ListBox1Click(Sender: TObject);
begin
 If updating then exit; // on ne fait rien si mode mise  jour
 Shape1.Shape := TShapeType(Listbox1.ItemIndex);
end;

// Couleur de la brosse
procedure TFEditTShape.ColorBox1Change(Sender: TObject);
begin
 If updating then exit;
 Shape1.Brush.Color := Colorbox1.Selected;
end;

// mode de la brosse, pleine ou non dessine
procedure TFEditTShape.RadioButton1Click(Sender: TObject);
begin
 If updating then exit;
 If RadioButton1.Checked then
  Shape1.Brush.Style := bsSolid else
  Shape1.Brush.Style := bsClear;
end;

// couleur du crayon
procedure TFEditTShape.ColorBox2Click(Sender: TObject);
begin
 If updating then exit;
 Shape1.Pen.Color := ColorBox2.Selected;
end;

// mode du crayon, plein ou non dssin
procedure TFEditTShape.RadioButton4Click(Sender: TObject);
begin
 If updating then exit;
 If RadioButton4.Checked then
  Shape1.Pen.Style := psSolid else
  Shape1.Pen.Style := psClear;
end;

// paisseur du crayon
procedure TFEditTShape.Edit2Change(Sender: TObject);
begin
 If updating then exit;
 Shape1.Pen.Width := UpDown1.Position;
end;

// hauteur de la forme
procedure TFEditTShape.TrackBar1Change(Sender: TObject);
begin
 If updating then exit;
 Shape1.Height := TrackBar1.Position;
 Label7.Caption:= IntToStr(Shape1.Height);
 CenterShape;
end;

// largeur de la forme
procedure TFEditTShape.TrackBar2Change(Sender: TObject);
begin
 If updating then exit;
 Shape1.Width  := TrackBar2.Position;
 Label8.Caption:= IntToStr(Shape1.Width);
 CenterShape;
end;

// La procdure d'dition  appeler de l'extrieur
Procedure EditTShape(LaForme:TShape);
begin
 with TFEditTShape.Create(Application) do
  try
    ShapeComponentName := LaForme.Name;
    InitShape(LaForme);
    If ShowModal=mrOk then CopyProps(Shape1,LaForme);
  finally
   Release;
  end;
end;

end.
