{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

{-----------------------------------------------------------------------------
 Unit Name: uTshapeEditor
 Author:    od
 Purpose:   Editeur de composant Tshape - Livre D7
 History:   mai 2002 - V 1.0
-----------------------------------------------------------------------------}



unit uTshapeEditor;

interface
uses DesignIntf,    // les units de design
     DesignEditors,
     DesignMenus,
     ExtCtrls,      // dfinition du TShape
     dialogs,       // pour le showmessage
     uCompEdit;     // le dialogue d'dition du composant

// L'diteur de composant
Type TShapeComponentEditor = Class (TComponentEditor)
    private
     fdejavu : boolean;
    public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
    procedure PrepareItem(Index: Integer; const AItem: IMenuItem); override;
    procedure Edit; override;
    end;

Procedure Register;

implementation

// enregistrement de l'diteur
Procedure Register;
begin
 RegisterComponentEditor(TShape,TShapeComponentEditor);
end;

// excution d'une des entres du menu contextuel
procedure TShapeComponentEditor.ExecuteVerb(Index: Integer);
begin
 case Index of
 0: begin
      Showmessage('Vous avez slectionn le composant '+Component.Name);
      fdejavu := true;
    end;
 1: Showmessage(' 2002 Olivier Dahan'#13#10'odahan@e-naxos.com'#13#10'Livre D7 Eyrolles');
 2: Edit;
 end; 
end;

// Retourne les libells du menu contextuel
function TShapeComponentEditor.GetVerb(Index: Integer): string;
begin
 case Index of
 0 : Result := 'Nom du composant [exemple]';
 1 : Result := 'A propos de l''diteur [exemple]';
 2 : Result := 'Editer le composant [exemple]';
 end;
end;

// retourne le nombre d'lments du menu contextuel
function TShapeComponentEditor.GetVerbCount: Integer;
begin
 Result := 3;
end;

// Est appel avant l'affichage de chaque item du menu
procedure TShapeComponentEditor.PrepareItem(Index: Integer; const AItem: IMenuItem);
begin
// on cochera l'item 0 s'il a dj t cliqu dans cette
// session d'dition
AItem.Checked := (Index=0) and fdejavu;
end;

// double clic sur le composant
procedure TShapeComponentEditor.Edit;
begin
 // appel de notre dialogue
 EditTShape(Tshape(Component));
 // on avertit le designer de la modification
 Designer.Modified;
end;

end.
