{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

{-----------------------------------------------------------------------------
 Unit Name: FName
 Author:    od
 Purpose:   Livre D7 - Editeur de proprit rudimentaire
 History:   mai-02 V 1.0
-----------------------------------------------------------------------------}

unit FName;

interface
uses Sysutils, DesignIntf, DesignEditors;

Type
 // l'diteur de proprit descend de l'diteur de chane
 TFileNameProperty = Class(TStringProperty)
  function GetAttributes : TPropertyAttributes; override;
  procedure Edit; override;
 end;

procedure Register;

implementation
uses dialogs; // pour utiliser le dialogue d'ouverture de fichier

function TFileNameProperty.GetAttributes: TPropertyAttributes;
begin
 Result := [paDialog]; // on indique que la proprit supporte un dialogue
end ;

// appel par l'inspecteur d'objet
// lorsque l'utilisateur clique sur le bouton "..."
procedure TFileNameProperty.Edit;
begin
 with TOpenDialog.Create(nil) do // on cr le dialogue
  try
   Title := 'Exemple Livre D7 : ' +GetName; // le nom de la proprit
   if GetValue<>'' then
    begin // on extrait le chemin et le nom de fichier
     InitialDir := ExtractFilePath(GetValue);
     FileName   := ExtractFileName(GetValue);
    end;
   Filter := 'Tous (*.*)|*.*';
   Options := Options + [ofPathMustExist, ofFileMustExist];
   // on excute le dialogue et on modifie la proprit si ok
   if Execute then SetValue(Filename);
  finally
   Free;
  end;
end;

// enregistrement de l'diteur dans l'IDE
procedure Register;
begin
 RegisterPropertyEditor(TypeInfo(TFileName),nil, '', TFileNameProperty);
end;


end.
