{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

// Livre D7 - Exemple d'expert se liant au clavier
// OD - juin 2002
// Une fois le package install utilisez CTRL-ALT + flche gauche ou droite
// pour indenter un bloc de texte

unit D7DemoIndentation;


interface

procedure Register;

implementation

uses Classes, SysUtils, Windows, Menus, ToolsAPI;


type
  TDemoIndentationKbd = class(TNotifierObject, IUnknown, IOTANotifier,
                             IOTAKeyboardBinding)
  protected
    procedure SlideBlock(const Context: IOTAKeyContext; Backward: Boolean);
    procedure IndentBlock(const Context: IOTAKeyContext; KeyCode: TShortCut;
                          var BindingResult: TKeyBindingResult);
  public
    function GetBindingType: TBindingType;
    function GetDisplayName: string;
    function GetName: string;
    procedure BindKeyboard(const BindingServices: IOTAKeyBindingServices);
  end;

resourcestring
  sBlockShift = 'CTRL-ALT <Flche G-D> Indente bloc';

procedure Register;
begin
  (BorlandIDEServices as IOTAKeyBoardServices).AddKeyboardBinding(TDemoIndentationKbd.Create);
end;

{ TDemoIndentationKbd }


procedure TDemoIndentationKbd.BindKeyboard(const BindingServices: IOTAKeyBindingServices);
begin
  BindingServices.AddKeyBinding([ShortCut(VK_RIGHT, [ssCtrl,ssAlt])], IndentBlock, nil);
  BindingServices.AddKeyBinding([ShortCut(VK_LEFT, [ssCtrl,ssAlt])], IndentBlock, Pointer(1));
end;

function TDemoIndentationKbd.GetBindingType: TBindingType;
begin
  Result := btPartial;
end;

function TDemoIndentationKbd.GetDisplayName: string;
begin
  Result := sBlockShift;
end;

function TDemoIndentationKbd.GetName: string;
begin
  Result := 'OD.LivreD7.Indentation';
end;

procedure TDemoIndentationKbd.IndentBlock(const Context: IOTAKeyContext;
  KeyCode: TShortCut; var BindingResult: TKeyBindingResult);
begin
  SlideBlock(Context, LongBool(Context.Context));
  BindingResult := krHandled;
end;

resourcestring
  sNoBlockMarked = 'Aucun bloc n''est marqu!';


procedure TDemoIndentationKbd.SlideBlock(const Context: IOTAKeyContext;
  Backward: Boolean);
var
  EB: IOTAEditBlock;
  IndentAmount: Integer;
begin
  EB := Context.EditBuffer.EditBlock;
  if EB.Size <> 0 then
  begin
    IndentAmount := 1; // ou bien := Context.KeyboardServices.EditorServices.EditOptions.BlockIndent;
    if Backward then
      IndentAmount := IndentAmount * -1;
    EB.Indent(IndentAmount);
  end else
    Context.EditBuffer.TopView.SetTempMsg(sNoBlockMarked);
end;


end.
