{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

{ exemple d'expert se liant aux vnements IDE }
{ Livre D7 - juin 2002 - OD                 }

unit D7IDENotification;

interface

procedure Register;

implementation

uses SysUtils, TypInfo, ToolsApi;

Var fIndexDuNotificateur: Integer = -1;

type
  TNotificateurIDE = class(TNotifierObject, IOTANotifier, IOTAIDENotifier)
  private
    fDureeCompilation : TDateTime;
  protected
    procedure AfterCompile(Succeeded: Boolean);
    procedure BeforeCompile(const Project: IOTAProject; var Cancel: Boolean);
    procedure FileNotification(NotifyCode: TOTAFileNotification;
      const FileName: string; var Cancel: Boolean);
    procedure Destroyed;
  end;

procedure Register;
var
  Services: IOTAServices;
begin
  Services := BorlandIDEServices as IOTAServices;
  if services=nil then raise exception.Create('Les services IDE ne sont pas disponibles')
   else fIndexDuNotificateur := Services.AddNotifier(TNotificateurIDE.Create);
end;

function MsgServices: IOTAMessageServices;
begin
  Result := (BorlandIDEServices as IOTAMessageServices);
  if result=nil then raise exception.Create('IOTAMessageServices non disponible');
end;


procedure TNotificateurIDE.AfterCompile(Succeeded: Boolean);
begin
  fDureeCompilation := now-fDureeCompilation;
  MsgServices.AddTitleMessage('<Dmo expert> Compilation termine  '+DateTimeToStr(now)+
                            ' ** Dure : '+timetostr(fDureeCompilation));
end;

procedure TNotificateurIDE.BeforeCompile(const Project: IOTAProject; var Cancel: Boolean);
begin
  MsgServices.AddTitleMessage('<Dmo expert> Compilation Commence  '+DateTimeToStr(now));
  fDureeCompilation := now;
end;

procedure TNotificateurIDE.FileNotification(NotifyCode: TOTAFileNotification;
  const FileName: string; var Cancel: Boolean);
begin
  MsgServices.AddTitleMessage('<Dmo Expert> '+Format('%s: %s',
    [GetEnumName(TypeInfo(TOTAFIleNotification), Ord(NotifyCode)), FileName]));
end;

Procedure RemoveExpert;
var
  Services: IOTAServices;
begin
  if fIndexDuNotificateur <> -1 then
  begin
    Services := BorlandIDEServices as IOTAServices;
    if services<>nil then
     begin
      Services.RemoveNotifier(fIndexDuNotificateur);
      fIndexDuNotificateur := -1;
     end;
  end;
end;

procedure TNotificateurIDE.Destroyed;
begin
 RemoveExpert;
end;


initialization
finalization
 RemoveExpert;
end.
