{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

// Dmo expert livre D7 : Module creator
// juin 2002 - OD

unit D7ModuleCreator;

interface

procedure Register;

implementation

uses SysUtils, Windows,
  DesignIntf,
  ToolsApi, 
  Dialogs;

type
  TDemoModuleCreatorWizard = class(TNotifierObject, 
                                   IOTAWizard, 
                                   IOTARepositoryWizard, 
                                   IOTAFormWizard)
  public
    // IOTAWizard
    function GetIDString: string;
    function GetName: string;
    function GetState: TWizardState;
    procedure Execute;
    // IOTARepositoryWizard
    function GetAuthor: string;
    function GetComment: string;
    function GetPage: string;
    function GetGlyph: Cardinal;
  end;

  TDemoModuleCreator = class(TInterfacedObject, IOTACreator, IOTAModuleCreator)
  public
    // IOTACreator
    function GetCreatorType: string;
    function GetExisting: Boolean;
    function GetFileSystem: string;
    function GetOwner: IOTAModule;
    function GetUnnamed: Boolean;
    // IOTAModuleCreator
    function GetAncestorName: string;
    function GetImplFileName: string;
    function GetIntfFileName: string;
    function GetFormName: string;
    function GetMainForm: Boolean;
    function GetShowForm: Boolean;
    function GetShowSource: Boolean;
    function NewFormFile(const FormIdent, AncestorIdent: string): IOTAFile;
    function NewImplSource(const ModuleIdent, FormIdent, AncestorIdent: string): IOTAFile;
    function NewIntfSource(const ModuleIdent, FormIdent, AncestorIdent: string): IOTAFile;
    procedure FormCreated(const FormEditor: IOTAFormEditor);
  end;

  TDemoSourceFile = class(TInterfacedObject, IOTAFile)
  private
    FSource: string;
  public
    function GetSource: string;
    function GetAge: TDateTime;
    constructor Create(const Source: string);
  end;

procedure Register;
begin
  RegisterPackageWizard(TDemoModuleCreatorWizard.Create);
end;

{ TDemoModuleCreatorWizard }

procedure TDemoModuleCreatorWizard.Execute;
begin
  (BorlandIDEServices as IOTAModuleServices).CreateModule(TDemoModuleCreator.Create);
end;

function TDemoModuleCreatorWizard.GetAuthor: string;
begin
  Result := 'Olivier Dahan';
end;

function TDemoModuleCreatorWizard.GetComment: string;
begin
  Result := 'Dmo d''expert "Module Creator"';
end;

function TDemoModuleCreatorWizard.GetGlyph: Cardinal;
begin
  Result := 0;
end;

function TDemoModuleCreatorWizard.GetIDString: string;
begin
  Result := 'OD.DEMO.TDemoModuleCreatorWizard';
end;

function TDemoModuleCreatorWizard.GetName: string;
begin
  Result := 'DemoModuleCreator';
end;

function TDemoModuleCreatorWizard.GetPage: string;
begin
  Result := 'Dmo-Livre-D7';
end;

function TDemoModuleCreatorWizard.GetState: TWizardState;
begin
  Result := [wsEnabled];
end;

{ TDemoModuleCreator }

procedure TDemoModuleCreator.FormCreated(const FormEditor: IOTAFormEditor);
begin
  // rien...
end;

function TDemoModuleCreator.GetAncestorName: string;
begin
  Result := 'Form';
end;

function TDemoModuleCreator.GetCreatorType: string;
begin
  Result := sForm;
  // ou bien sUnit ou sText selon ce qu'on dsire obtenir
end;

function TDemoModuleCreator.GetExisting: Boolean;
begin
  Result := False;
end;

function TDemoModuleCreator.GetFileSystem: string;
begin
  Result := '';
end;

function TDemoModuleCreator.GetFormName: string;
begin
  Result := '';
end;

function TDemoModuleCreator.GetImplFileName: string;
begin
  Result := '';
end;

function TDemoModuleCreator.GetIntfFileName: string;
begin
  Result := '';
end;

function TDemoModuleCreator.GetMainForm: Boolean;
begin
  Result := False;
end;

function TDemoModuleCreator.GetOwner: IOTAModule;
var
  ModuleServices: IOTAModuleServices;
  Module: IOTAModule;
  NewModule: IOTAModule;
begin
  Result := nil;
  ModuleServices := (BorlandIDEServices as IOTAModuleServices);
  Module := ModuleServices.CurrentModule;

  if Module <> nil then
  begin
    if Module.QueryInterface(IOTAProject, NewModule) = S_OK then
      Result := NewModule
    else if Module.OwnerModuleCount > 0 then
    begin
      NewModule := Module.OwnerModules[0];
      if NewModule <> nil then
        if NewModule.QueryInterface(IOTAProject, Result) <> S_OK then
          Result := nil;
    end;
  end;
end;

function TDemoModuleCreator.GetShowForm: Boolean;
begin
  Result := True;
end;

function TDemoModuleCreator.GetShowSource: Boolean;
begin
  Result := True;
end;

function TDemoModuleCreator.GetUnnamed: Boolean;
begin
  Result := True;
end;

function TDemoModuleCreator.NewFormFile(const FormIdent, AncestorIdent: string): IOTAFile;
begin
  Result := nil;
end;

function TDemoModuleCreator.NewImplSource(const ModuleIdent, FormIdent, AncestorIdent: string): IOTAFile;
const
  CRLF = #13#10;
var sSource : string;
begin
 sSource :=
  'unit %s;' + #13#10 +
  '// ------------------------------------------'+CRLF+
  '// Cr avec TDemoModuleCreator le '+DateTimeToStr(now)+ CRLF+
  '// ------------------------------------------'+CRLF+
  '' + #13#10 +
  'interface' + CRLF + CRLF +
  'uses' + CRLF +
  '  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;' + CRLF +
  CRLF +
  'type' + CRLF +
  '  T%s = class(T%s)' + CRLF +
  '  private' + CRLF +
  '    { Dclarations prive de dmo }' + CRLF +
  '  public' + CRLF +
  '    { Dclarations publiques de dmo }' + CRLF +
  '  end;' + CRLF + CRLF +
  'var' + CRLF +
  '  %s: T%s;' + CRLF + CRLF +
  '// **************'+ CRLF +
  '   implementation' + CRLF +
  '// **************'+ CRLF + CRLF +
  '{$R *.DFM}' + CRLF + CRLF +
  'end. // fin de l''unit gnre';

  Result := TDemoSourceFile.Create(Format(sSource, [ModuleIdent, FormIdent,
                           AncestorIdent, FormIdent, FormIdent]));
  // ou Result := nil; pour utiliser l'unit par dfaut
end;

function TDemoModuleCreator.NewIntfSource(const ModuleIdent, FormIdent, AncestorIdent: string): IOTAFile;
begin
  Result := nil;
end;

{ TDemoSourceFile }

constructor TDemoSourceFile.Create(const Source: string);
begin
  FSource := Source;
end;

function TDemoSourceFile.GetAge: TDateTime;
begin
  Result := -1;
end;

function TDemoSourceFile.GetSource: string;
begin
  Result := FSource;
end;

end.

