{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

{-----------------------------------------------------------------------------
 Unit Name: Unit1
 Author:    od
 Purpose:   Design Pattern "Adapter" - Exemple
 History:   mai 2002 - v1.0
-----------------------------------------------------------------------------}



unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ExtCtrls,
  uOldClass,      // l'ancienne classe
  uNewClass,      // la nouvelle
  uAdapter;       // l'ancienne adapte

type
  TForm1 = class(TForm)
    Bevel1: TBevel;
    Label1: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Bevel2: TBevel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    Bevel3: TBevel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    Label12: TLabel;
    Edit7: TEdit;
    Label13: TLabel;
    Edit8: TEdit;
    SpeedButton10: TSpeedButton;
    Edit9: TEdit;
    SpeedButton11: TSpeedButton;
    Edit10: TEdit;
    SpeedButton12: TSpeedButton;
    Edit11: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure SpeedButton11Click(Sender: TObject);
    procedure SpeedButton12Click(Sender: TObject);
  private
    { Dclarations prives }
    fOld : TOldClass;         // ancienne classe
    fnew : TNewClass;         // nouvelle classe
    fAdapter: TAdapterClass;  // ancienne classe adapte
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
 fold := TOldClass.Create;
 fnew := TNewClass.Create;
 fAdapter := TAdapterClass.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 fOld.Free;
 fNew.Free;
 fAdapter.Free;
end;

// accs  l'ancienne classe
procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
 edit2.Text := fold.GetTexte;
 edit1.text := inttostr(fold.GetNum);
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
 fold.SetTexte(edit2.text);
 fold.SetNum(strTointDef(edit1.text,0));
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
 edit1.Text := '';
 edit2.Text := '';
 edit9.text := '';
end;

procedure TForm1.SpeedButton10Click(Sender: TObject);
begin
 edit9.Text := fold.MethodeUtile;
end;


// accs  la nouvelle classe
procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
 fnew.Num   := strtofloatDef(edit3.Text,0);
 fnew.Texte := edit4.Text;
 fnew.char  := copy(edit7.Text+#0,1,1)[1];
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
 edit3.Text := floattostr(fnew.Num);
 edit4.Text := fnew.Texte;
 edit7.Text := fnew.Char;
end;


procedure TForm1.SpeedButton6Click(Sender: TObject);
begin
 edit3.Text := '';
 edit4.Text := '';
 edit7.Text := '';
 edit10.text := '';
end;

procedure TForm1.SpeedButton11Click(Sender: TObject);
begin
 edit10.Text := fnew.NouvelleMethode;
end;


// accs  la classe adapte
procedure TForm1.SpeedButton7Click(Sender: TObject);
begin
 edit5.Text := floattostr(fadapter.Num);
 edit6.Text := fadapter.Texte;
 edit8.Text := fadapter.Char;
end;                                  

procedure TForm1.SpeedButton8Click(Sender: TObject);
begin
 fadapter.Num   := strtofloatDef(edit5.Text,0);
 fadapter.Texte := edit6.Text;
 fadapter.char  := copy(edit8.Text+#0,1,1)[1];
end;

procedure TForm1.SpeedButton9Click(Sender: TObject);
begin
 edit5.Text := '';
 edit6.Text := '';
 edit8.Text := '';
 edit11.text := '';
end;



procedure TForm1.SpeedButton12Click(Sender: TObject);
begin
 edit11.Text := fadapter.NouvelleMethode;
end;

end.
