{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

{-----------------------------------------------------------------------------
 Unit Name: uAdapter
 Author:    od
 Purpose:   DP "adapter"
            Dfinition de la classe Adaptateur qui permettra d'utiliser
            l'ancienne classe dans les nouvelles applications
 History:   mai 2002 - v1.0
-----------------------------------------------------------------------------}

unit uAdapter;

interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,
  uOldClass,  // unit dcrivant l'ancienne classe
  uNewClass;  // unit dcrivant la nouvelle classe

type
 TAdapterClass = Class(TNewClass) // on hrite de la nouvelle classe
  private
   // on utilise en interne l'ancienne classe
   FOldClass : TOldClass;
  protected
   // les accesseurs concernant l'ancienne classe sont surchargs
   procedure SetTexte(s:string); override;
   function  GetTexte : string; override;
   procedure SetNum(v:double); override;
   function  GetNum:double; override;
   // les accesseurs des nouveaux champs ne sont pas concerns
  public
   // les constructeur et destructeur sont surchargs
   constructor Create; virtual;
   destructor  Destroy; override;
   // les dfinitions de proprits ne sont pas concerne
   // mais la mthode NouvelleMethode est surcharge
   function NouvelleMethode : string; override;
  end;

implementation

constructor TAdapterClass.Create;
begin
 inherited create;
 // on cr l'instance interne de l'ancienne classe
 FOldClass := TOldClass.Create;
end;

destructor TAdapterClass.Destroy;
begin
 FOldClass.Free;
 inherited Destroy;
end;


procedure TAdapterClass.SetTexte(s:string);
begin
 if length(s)>30 then {condition  traiter} else
   FOldClass.SetTexte(s); // on dlgue  l'ancienne classe
end;

function  TAdapterClass.GetTexte : string;    
begin
 result := FOldClass.GetTexte; // dlgu  l'ancienne classe
end;

procedure TAdapterClass.SetNum(v:double);
var i:integer;
begin
 if v>maxint then {erreur  traiter};
 i := trunc(v); // on adapte pour l'ancienne classe
 FOldClass.SetNum(i);
end;

function  TAdapterClass.GetNum:double;
begin
 result := FOldClass.GetNum;
end;

function TAdapterClass.NouvelleMethode : string;
begin
 result := '['+self.char+']'+fOldClass.MethodeUtile;
end;

end.
