{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

{-----------------------------------------------------------------------------
 Unit Name: Unit1
 Author:    od
 Purpose:   Dmonstration de la Design Pattern "Observer"
 History:   mai 2002 v1.0
-----------------------------------------------------------------------------}


unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,
  uObserver,  // la classe "observe"
  uStats,     // la fiche "stats" "observateur"
  uInfos;     // la fiche "infos" "observateur"

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Bevel1: TBevel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    btOutput: TButton;
    btInput: TButton;
    btStats: TButton;
    btInfos: TButton;
    btReset: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btInputClick(Sender: TObject);
    procedure btOutputClick(Sender: TObject);
    procedure btResetClick(Sender: TObject);
    procedure btStatsClick(Sender: TObject);
    procedure btInfosClick(Sender: TObject);
  private
    { Dclarations prives }
    os : TObservedStock;
    procedure UpdateDisplay;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
 os:=TObservedStock.create; // cration de l'objet observ
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 os.free; // libration de l'objet observ
end;

procedure TForm1.btInputClick(Sender: TObject);
begin
 os.Input := StrToIntDef(Edit1.Text,0); // entre en stock
 UpdateDisplay;                         // maj affichage
end;

procedure TForm1.btOutputClick(Sender: TObject);
begin
 os.Output := StrToIntDef(edit2.Text,0); // sortie de stock
 UpdateDisplay;
end;

procedure TForm1.btResetClick(Sender: TObject);
begin
 os.ResetStock; // remise  zro des entre et sorties
 UpdateDisplay;
end;

procedure TForm1.UpdateDisplay;
begin
 // mise  jour affichage
 label7.caption :=formatfloat('#,##0',os.Input);
 label8.caption :=formatfloat('#,##0',os.Output);
 label9.caption :=formatfloat('#,##0',os.Stock);
end;

procedure TForm1.btStatsClick(Sender: TObject);
begin
 // cration d'une instance de la fiche Stats
 with Tform2.Create(self) do
  begin
   // enregistrement de la mthode d'observation des stats
   os.RegisterObserver(Observe,ot_all);
   // rfrence pour dsenregistrement
   observer := os;
   show; // affichage stats
  end;
end;

procedure TForm1.btInfosClick(Sender: TObject);
begin
 // cration d'une instance de la fiche Infos
 with Tform3.Create(self) do
  begin
   // enregistrement de la mthode d'observation des infos
   os.RegisterObserver(Observe,ot_all);
   // rfrence pour dsenregistrement
   observer := os;
   show; // affichage infos
  end;
end;

end.
