{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

{-----------------------------------------------------------------------------
 Unit Name: ustats
 Author:    od
 Purpose:   dmo design pattern "observer"
            fiche de stats "observatrice"
 History:   mai 2002 v1.0
-----------------------------------------------------------------------------}

unit ustats;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Series, TeEngine, ExtCtrls, TeeProcs, Chart, uobserver;

type
  TForm2 = class(TForm)
    Chart1: TChart;
    sInput: TBarSeries;
    sOutput: TBarSeries;
    sStock: TBarSeries;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
  private
  public
    // rfrence de l'observer pour dsenregistrement
    Observer : TObservedStock;
    // mthode callback enregistre auprs de l'objet observ
    Procedure Observe(Observed:TObservedStock;Event:TObservationType);
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

Procedure TForm2.Observe(Observed:TObservedStock;Event:TObservationType);
begin
 // mise  jour du graphique
 sInput.Clear;
 sInput.Add(Observed.Input);
 sOutput.Clear;
 sOutput.Add(Observed.Output);
 sStock.Clear;
 sStock.Add(Observed.Stock);
end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 action := caFree; // libration de la form sur fermeture
end;

procedure TForm2.FormDestroy(Sender: TObject);
begin
 Observer.UnregisterObserver(observe); // dsenregistrement
end;

end.
