{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

{-----------------------------------------------------------------------------
 Unit Name: uSingletonVrai
 Author:    od
 Purpose:   Demonstration de la pattern Singleton
            Cet exemple utilise l'approche la plus fiable
 History:   mai 2002 - v1.0
-----------------------------------------------------------------------------}

unit uSingletonVrai;

interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;

Type
 // la classe
 TSingletonVrai = Class
  public
   constructor Create; virtual;
   destructor destroy; override;
   // est la seule porte d'accs  l'instance
   class function Instance : TSingletonVrai;
   // une mthode exemple (dummy)
   function UneMethode : TDateTime;
  end;

 // variante pour viter l'utilisation
 // de la mthode de classe
 Function LeSingletonVrai : TSingletonVrai;

implementation
// fait office d'attribut de classe, notion non implmente
// dans Delphi
var UneInstance : TSingletonVrai = nil;

// le constructeur refuse la cration d'un doublon
constructor TSingletonVrai.Create;
begin
 if UneInstance=nil then inherited create
  else raise exception.create('Une seule instance autorise');
end;

destructor TSingletonVrai.destroy;
begin
 if UneInstance = Self then
  UneInstance := Nil; // raz du faux attribut de classe
 inherited destroy;
end;

class function TSingletonVrai.Instance : TSingletonVrai;
begin
 if UneInstance=nil then UneInstance := TSingletonVrai.Create;
 Result := UneInstance;
end;

// une mthode exemple de l'objet
function TSingletonVrai.UneMethode : TDateTime;
begin
 result := now;
end;

Function LeSingletonVrai : TSingletonVrai;
begin
 // on pointe la mthode de classe retournant l'instance 
 result := TSingletonVrai.Instance;
end;

initialization
finalization
 If assigned(UneInstance) then UneInstance.Free;
end.
