{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

{-----------------------------------------------------------------------------
 Unit Name: usingleton
 Author:    od
 Purpose:   dmontre la design pattern Singleton
            Cet exemple utilise la version "light" par fonction
            comme pour Printer dans la VCL
            Ce n'est pas un vrai singleton, la classe ne gre pas la
            contrainte.
 History:   mai 2002. V 1.0
-----------------------------------------------------------------------------}



unit usingleton;

interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;


Type
 // La classe qui sera utilise " la " Singleton
 TSingleton = Class
  private
   FUnChamp : integer; // donne d'exemple
  public
   // accs au champ exemple
   procedure SetChamp(value:integer);
   function GetChamp:integer;
  end;

 // Mthode A - par le biais d'une fonction
 // jouant le rle de variable globale
 Function LeSingleton : TSingleton;

implementation

var Singleton : Tsingleton = nil; // joue le rle d'attribut de classe

Function LeSingleton : TSingleton;
begin
 // cr le singleton s'il n'existe pas
 if not assigned(Singleton) then Singleton:=TSingleton.Create;
 Result := singleton; // retourne l'instance
end;


procedure TSingleton.SetChamp(value:integer);
begin
 FUnChamp := value;
end;

function TSingleton.GetChamp:integer;
begin
 Result := FUnChamp;
end;

initialization
finalization
 // supprime le singleton en fin d'application
 if assigned(Singleton) then Singleton.Free; 
end.
