{ *********************************************************
  * LIVRE Delphi 7 Studio - De l'analyse  la ralisation *
  * Ed.EYROLLES, PARIS                                    *
  *********************************************************
  * Copyrights 2002 Olivier DAHAN:. - Paul TOTH           *
  *********************************************************
  * Le code fourni ici l'est uniquement  titre d'exemple *
  * Aucune "maintenance" ne sera fournie.                 *
  *********************************************************

}

{-----------------------------------------------------------------------------
 Unit Name: Unit2
 Author:    od
 Purpose:   Design Pattern example. "Template"
 History:   mai 2002 v1.0
-----------------------------------------------------------------------------}

unit utemplate;

interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;

type
 // Dfinit la classe Template
 TAlgoTemplate = Class
  protected
   fResult : string;          // contiendra le rsultat (example)
   procedure Step1; virtual; abstract; // mthodes abstraites !
   procedure Step2; virtual; abstract;
   procedure Step3; virtual; abstract;
  public
   procedure Execute; virtual; // mthode qui execute
   property result : string read fresult;
  end;

 TAlgoReel1 = Class(TAlgoTemplate)
   protected
    procedure Step1; override;   // surchage des mthodes abstraites
    procedure Step2; override;
    procedure Step3; override;
   end;

 TAlgoReel2 = Class(TAlgoTemplate)
   protected
    procedure Step1; override;   // surchage des mthodes abstraites
    procedure Step2; override;
    procedure Step3; override;
   end;


implementation

// ** mthode du template **
procedure TAlgoTemplate.Execute;
begin
 Step1;
 Step2;
 Step3;
end;

// ** mthodes de l'algo rel 1 **

procedure TAlgoReel1.Step1;
begin
 fresult:='A'; // traitement dummy
end;

procedure TAlgoReel1.Step2;
begin
 fresult := fresult+fresult; // traitement dummy
end;

procedure TAlgoReel1.Step3;
begin
 fresult:='['+fresult+']';
end;


// ** mthodes de l'algo rel 2 **

procedure TAlgoReel2.Step1;
begin
 fresult:='B'; // traitement dummy       
end;

procedure TAlgoReel2.Step2;
begin
 fresult := fresult+'C'; // traitement dummy
end;

procedure TAlgoReel2.Step3;
begin
 fresult:='{'+fresult+'}';
end;

end.
